import{S as rl,i as il,s as ll,e as n,k as d,w as k,t as r,M as dl,c as a,d as o,m as c,a as s,x as v,h as i,b as l,G as e,g as u,y as b,q as y,o as L,B as $,v as cl,L as Bn}from"../../chunks/vendor-hf-doc-builder.js";import{T as Br}from"../../chunks/Tip-hf-doc-builder.js";import{D as C}from"../../chunks/Docstring-hf-doc-builder.js";import{C as to}from"../../chunks/CodeBlock-hf-doc-builder.js";import{I as Ce}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{E as jn}from"../../chunks/ExampleCodeBlock-hf-doc-builder.js";function ml(x){let p,T;return p=new to({props:{code:`from transformers import LlamaModel, LlamaConfig

# Initializing a LLaMA llama-7b style configuration
configuration = LlamaConfig()

# Initializing a model from the llama-7b style configuration
model = LlamaModel(configuration)

# Accessing the model configuration
configuration = model.config`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> LlamaModel, LlamaConfig

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a LLaMA llama-7b style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = LlamaConfig()

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a model from the llama-7b style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = LlamaModel(configuration)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Accessing the model configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = model.config`}}),{c(){k(p.$$.fragment)},l(h){v(p.$$.fragment,h)},m(h,_){b(p,h,_),T=!0},p:Bn,i(h){T||(y(p.$$.fragment,h),T=!0)},o(h){L(p.$$.fragment,h),T=!1},d(h){$(p,h)}}}function pl(x){let p,T,h,_,w;return _=new to({props:{code:`0 0 0 0 0 0 0 0 0 0 0 1 1 1 1 1 1 1 1 1
| first sequence    | second sequence |`,highlighted:`0<span class="hljs-number"> 0 </span>0<span class="hljs-number"> 0 </span>0<span class="hljs-number"> 0 </span>0<span class="hljs-number"> 0 </span>0<span class="hljs-number"> 0 </span>0<span class="hljs-number"> 1 </span>1<span class="hljs-number"> 1 </span>1<span class="hljs-number"> 1 </span>1<span class="hljs-number"> 1 </span>1 1
| first sequence    | second sequence |`}}),{c(){p=n("p"),T=r("sequence pair mask has the following format:"),h=d(),k(_.$$.fragment)},l(f){p=a(f,"P",{});var g=s(p);T=i(g,"sequence pair mask has the following format:"),g.forEach(o),h=c(f),v(_.$$.fragment,f)},m(f,g){u(f,p,g),e(p,T),u(f,h,g),b(_,f,g),w=!0},p:Bn,i(f){w||(y(_.$$.fragment,f),w=!0)},o(f){L(_.$$.fragment,f),w=!1},d(f){f&&o(p),f&&o(h),$(_,f)}}}function hl(x){let p,T;return p=new to({props:{code:`
[1, 15043, 445, 338, 263, 1243]`,highlighted:`<span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> LlamaTokenizerFast

tokenizer = LlaTokenizerFast.from_pretrained(&quot;hf-internal-testing/llama-tokenizer&quot;)
tokenizer.encode(&quot;Hello this is a test&quot;)
&gt;&gt;&gt; [<span class="hljs-number">1</span>, <span class="hljs-number">15043</span>, <span class="hljs-number">445</span>, <span class="hljs-number">338</span>, <span class="hljs-number">263</span>, <span class="hljs-number">1243</span>]`}}),{c(){k(p.$$.fragment)},l(h){v(p.$$.fragment,h)},m(h,_){b(p,h,_),T=!0},p:Bn,i(h){T||(y(p.$$.fragment,h),T=!0)},o(h){L(p.$$.fragment,h),T=!1},d(h){$(p,h)}}}function fl(x){let p,T,h,_,w;return{c(){p=n("p"),T=r("Although the recipe for forward pass needs to be defined within this function, one should call the "),h=n("code"),_=r("Module"),w=r(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(f){p=a(f,"P",{});var g=s(p);T=i(g,"Although the recipe for forward pass needs to be defined within this function, one should call the "),h=a(g,"CODE",{});var P=s(h);_=i(P,"Module"),P.forEach(o),w=i(g,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),g.forEach(o)},m(f,g){u(f,p,g),e(p,T),e(p,h),e(h,_),e(p,w)},d(f){f&&o(p)}}}function ul(x){let p,T,h,_,w;return{c(){p=n("p"),T=r("Although the recipe for forward pass needs to be defined within this function, one should call the "),h=n("code"),_=r("Module"),w=r(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(f){p=a(f,"P",{});var g=s(p);T=i(g,"Although the recipe for forward pass needs to be defined within this function, one should call the "),h=a(g,"CODE",{});var P=s(h);_=i(P,"Module"),P.forEach(o),w=i(g,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),g.forEach(o)},m(f,g){u(f,p,g),e(p,T),e(p,h),e(h,_),e(p,w)},d(f){f&&o(p)}}}function _l(x){let p,T,h,_,w;return _=new to({props:{code:`from transformers import AutoTokenizer, LlamaForCausalLM

model = LlamaForCausalLM.from_pretrained(PATH_TO_CONVERTED_WEIGHTS)
tokenizer = AutoTokenizer.from_pretrained(PATH_TO_CONVERTED_TOKENIZER)

prompt = "Hey, are you consciours? Can you talk to me?"
inputs = tokenizer(prompt, return_tensors="pt")

# Generate
generate_ids = model.generate(inputs.input_ids, max_length=30)
tokenizer.batch_decode(generate_ids, skip_special_tokens=True, clean_up_tokenization_spaces=False)[0]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, LlamaForCausalLM

<span class="hljs-meta">&gt;&gt;&gt; </span>model = LlamaForCausalLM.from_pretrained(PATH_TO_CONVERTED_WEIGHTS)
<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(PATH_TO_CONVERTED_TOKENIZER)

<span class="hljs-meta">&gt;&gt;&gt; </span>prompt = <span class="hljs-string">&quot;Hey, are you consciours? Can you talk to me?&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(prompt, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Generate</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>generate_ids = model.generate(inputs.input_ids, max_length=<span class="hljs-number">30</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer.batch_decode(generate_ids, skip_special_tokens=<span class="hljs-literal">True</span>, clean_up_tokenization_spaces=<span class="hljs-literal">False</span>)[<span class="hljs-number">0</span>]
<span class="hljs-string">&quot;Hey, are you consciours? Can you talk to me?\\nI&#x27;m not consciours, but I can talk to you.&quot;</span>`}}),{c(){p=n("p"),T=r("Example:"),h=d(),k(_.$$.fragment)},l(f){p=a(f,"P",{});var g=s(p);T=i(g,"Example:"),g.forEach(o),h=c(f),v(_.$$.fragment,f)},m(f,g){u(f,p,g),e(p,T),u(f,h,g),b(_,f,g),w=!0},p:Bn,i(f){w||(y(_.$$.fragment,f),w=!0)},o(f){L(_.$$.fragment,f),w=!1},d(f){f&&o(p),f&&o(h),$(_,f)}}}function gl(x){let p,T,h,_,w;return{c(){p=n("p"),T=r("Although the recipe for forward pass needs to be defined within this function, one should call the "),h=n("code"),_=r("Module"),w=r(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(f){p=a(f,"P",{});var g=s(p);T=i(g,"Although the recipe for forward pass needs to be defined within this function, one should call the "),h=a(g,"CODE",{});var P=s(h);_=i(P,"Module"),P.forEach(o),w=i(g,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),g.forEach(o)},m(f,g){u(f,p,g),e(p,T),e(p,h),e(h,_),e(p,w)},d(f){f&&o(p)}}}function kl(x){let p,T,h,_,w,f,g,P,Wn,Uo,X,ie,oo,xe,Hn,no,Rn,Xo,le,Gn,qe,Vn,Un,Jo,Tt,Xn,Ko,wt,ao,Jn,Zo,zt,Kn,Qo,de,Et,Zn,Pe,Qn,Yn,Ae,ea,Ie,ta,oa,Yo,Oe,en,Mt,so,na,tn,Se,on,Ft,aa,nn,Ct,De,sa,Ne,ra,ia,an,A,la,je,da,ca,Be,ma,pa,We,ha,fa,He,ua,_a,sn,J,ce,ro,Re,ga,io,ka,rn,O,Ge,va,Ve,ba,xt,ya,La,$a,K,Ta,qt,wa,za,Pt,Ea,Ma,Fa,me,ln,Z,pe,lo,Ue,Ca,co,xa,dn,F,Xe,qa,mo,Pa,Aa,At,Je,Ia,he,Ke,Oa,Ze,Sa,po,Da,Na,ja,D,Qe,Ba,ho,Wa,Ha,fe,Ra,fo,Ga,Va,ue,Ye,Ua,uo,Xa,cn,Q,_e,_o,et,Ja,go,Ka,mn,z,tt,Za,ko,Qa,Ya,vo,es,ts,ge,os,ot,ns,It,as,ss,rs,B,nt,is,bo,ls,ds,yo,cs,ms,ke,at,ps,Y,hs,Lo,fs,us,$o,_s,gs,ks,W,st,vs,Ot,bs,St,ys,Ls,To,$s,Ts,Dt,rt,pn,ee,ve,wo,it,ws,zo,zs,hn,q,lt,Es,dt,Ms,Nt,Fs,Cs,xs,ct,qs,mt,Ps,As,Is,be,Os,Eo,Ss,Ds,Mo,Ns,js,H,pt,Bs,te,Ws,jt,Hs,Rs,Fo,Gs,Vs,Us,ye,fn,oe,Le,Co,ht,Xs,xo,Js,un,ne,ft,Ks,N,ut,Zs,ae,Qs,Bt,Ys,er,qo,tr,or,nr,$e,ar,Te,_n,se,we,Po,_t,sr,Ao,rr,gn,E,gt,ir,Io,lr,dr,Wt,Ht,cr,mr,pr,S,hr,Oo,fr,ur,So,_r,gr,Do,kr,vr,No,br,yr,Lr,kt,$r,Rt,Tr,wr,zr,vt,Er,bt,Mr,Fr,Cr,R,yt,xr,re,qr,Gt,Pr,Ar,jo,Ir,Or,Sr,ze,kn;return f=new Ce({}),xe=new Ce({}),Oe=new to({props:{code:`python src/transformers/models/llama/convert_llama_weights_to_hf.py \\
    --input_dir /path/to/downloaded/llama/weights --model_size 7B --output_dir /output/path`,highlighted:`python src/transformers/models/llama/convert_llama_weights_to_hf.py \\
    --input_dir /path/to/downloaded/llama/weights --model_size 7B --output_dir /output/path`}}),Se=new to({props:{code:`from transformers import LlamaForCausalLM, LlamaTokenizer

tokenizer = LlamaTokenizer.from_pretrained("/output/path")
model = LlamaForCausalLM.from_pretrained("/output/path")`,highlighted:`<span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> LlamaForCausalLM, LlamaTokenizer

tokenizer = LlamaTokenizer.from_pretrained(<span class="hljs-string">&quot;/output/path&quot;</span>)
model = LlamaForCausalLM.from_pretrained(<span class="hljs-string">&quot;/output/path&quot;</span>)`}}),Re=new Ce({}),Ge=new C({props:{name:"class transformers.LlamaConfig",anchor:"transformers.LlamaConfig",parameters:[{name:"vocab_size",val:" = 32000"},{name:"hidden_size",val:" = 4096"},{name:"intermediate_size",val:" = 11008"},{name:"num_hidden_layers",val:" = 32"},{name:"num_attention_heads",val:" = 32"},{name:"hidden_act",val:" = 'silu'"},{name:"max_position_embeddings",val:" = 2048"},{name:"initializer_range",val:" = 0.02"},{name:"rms_norm_eps",val:" = 1e-06"},{name:"use_cache",val:" = True"},{name:"pad_token_id",val:" = 0"},{name:"bos_token_id",val:" = 1"},{name:"eos_token_id",val:" = 2"},{name:"tie_word_embeddings",val:" = False"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.LlamaConfig.vocab_size",description:`<strong>vocab_size</strong> (<code>int</code>, <em>optional</em>, defaults to 32000) &#x2014;
Vocabulary size of the LLaMA model. Defines the number of different tokens that can be represented by the
<code>inputs_ids</code> passed when calling <a href="/docs/transformers/pr_21990/en/model_doc/llama#transformers.LlamaModel">LlamaModel</a>`,name:"vocab_size"},{anchor:"transformers.LlamaConfig.hidden_size",description:`<strong>hidden_size</strong> (<code>int</code>, <em>optional</em>, defaults to 4096) &#x2014;
Dimension of the hidden representations.`,name:"hidden_size"},{anchor:"transformers.LlamaConfig.intermediate_size",description:`<strong>intermediate_size</strong> (<code>int</code>, <em>optional</em>, defaults to 11008) &#x2014;
Dimension of the MLP representations.`,name:"intermediate_size"},{anchor:"transformers.LlamaConfig.num_hidden_layers",description:`<strong>num_hidden_layers</strong> (<code>int</code>, <em>optional</em>, defaults to 32) &#x2014;
Number of hidden layers in the Transformer encoder.`,name:"num_hidden_layers"},{anchor:"transformers.LlamaConfig.num_attention_heads",description:`<strong>num_attention_heads</strong> (<code>int</code>, <em>optional</em>, defaults to 32) &#x2014;
Number of attention heads for each attention layer in the Transformer encoder.`,name:"num_attention_heads"},{anchor:"transformers.LlamaConfig.hidden_act",description:`<strong>hidden_act</strong> (<code>str</code> or <code>function</code>, <em>optional</em>, defaults to <code>&quot;silu&quot;</code>) &#x2014;
The non-linear activation function (function or string) in the decoder.`,name:"hidden_act"},{anchor:"transformers.LlamaConfig.max_position_embeddings",description:`<strong>max_position_embeddings</strong> (<code>int</code>, <em>optional</em>, defaults to 2048) &#x2014;
The maximum sequence length that this model might ever be used with. Typically set this to something large
just in case (e.g., 512 or 1024 or 2048).`,name:"max_position_embeddings"},{anchor:"transformers.LlamaConfig.initializer_range",description:`<strong>initializer_range</strong> (<code>float</code>, <em>optional</em>, defaults to 0.02) &#x2014;
The standard deviation of the truncated_normal_initializer for initializing all weight matrices.`,name:"initializer_range"},{anchor:"transformers.LlamaConfig.rms_norm_eps",description:`<strong>rms_norm_eps</strong> (<code>float</code>, <em>optional</em>, defaults to 1e-12) &#x2014;
The epsilon used by the rms normalization layers.`,name:"rms_norm_eps"},{anchor:"transformers.LlamaConfig.use_cache",description:`<strong>use_cache</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not the model should return the last key/values attentions (not used by all models). Only
relevant if <code>config.is_decoder=True</code>.`,name:"use_cache"},{anchor:"transformers.LlamaConfig.tie_word_embeddings(bool,",description:`<strong>tie_word_embeddings(<code>bool</code>,</strong> <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to tie weight embeddings
Example &#x2014;`,name:"tie_word_embeddings(bool,"}],source:"https://github.com/huggingface/transformers/blob/vr_21990/src/transformers/models/llama/configuration_llama.py#L31"}}),me=new jn({props:{anchor:"transformers.LlamaConfig.example",$$slots:{default:[ml]},$$scope:{ctx:x}}}),Ue=new Ce({}),Xe=new C({props:{name:"class transformers.LlamaTokenizer",anchor:"transformers.LlamaTokenizer",parameters:[{name:"vocab_file",val:""},{name:"unk_token",val:" = '<unk>'"},{name:"bos_token",val:" = '<s>'"},{name:"eos_token",val:" = '</s>'"},{name:"pad_token",val:" = None"},{name:"sp_model_kwargs",val:": typing.Union[typing.Dict[str, typing.Any], NoneType] = None"},{name:"add_bos_token",val:" = True"},{name:"add_eos_token",val:" = False"},{name:"clean_up_tokenization_spaces",val:" = False"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.LlamaTokenizer.vocab_file",description:`<strong>vocab_file</strong> (<code>str</code>) &#x2014;
Path to the vocabulary file.`,name:"vocab_file"}],source:"https://github.com/huggingface/transformers/blob/vr_21990/src/transformers/models/llama/tokenization_llama.py#L49"}}),Je=new C({props:{name:"build_inputs_with_special_tokens",anchor:"transformers.LlamaTokenizer.build_inputs_with_special_tokens",parameters:[{name:"token_ids_0",val:""},{name:"token_ids_1",val:" = None"}],source:"https://github.com/huggingface/transformers/blob/vr_21990/src/transformers/models/llama/tokenization_llama.py#L178"}}),Ke=new C({props:{name:"get_special_tokens_mask",anchor:"transformers.LlamaTokenizer.get_special_tokens_mask",parameters:[{name:"token_ids_0",val:": typing.List[int]"},{name:"token_ids_1",val:": typing.Optional[typing.List[int]] = None"},{name:"already_has_special_tokens",val:": bool = False"}],parametersDescription:[{anchor:"transformers.LlamaTokenizer.get_special_tokens_mask.token_ids_0",description:`<strong>token_ids_0</strong> (<code>List[int]</code>) &#x2014;
List of IDs.`,name:"token_ids_0"},{anchor:"transformers.LlamaTokenizer.get_special_tokens_mask.token_ids_1",description:`<strong>token_ids_1</strong> (<code>List[int]</code>, <em>optional</em>) &#x2014;
Optional second list of IDs for sequence pairs.`,name:"token_ids_1"},{anchor:"transformers.LlamaTokenizer.get_special_tokens_mask.already_has_special_tokens",description:`<strong>already_has_special_tokens</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not the token list is already formatted with special tokens for the model.`,name:"already_has_special_tokens"}],source:"https://github.com/huggingface/transformers/blob/vr_21990/src/transformers/models/llama/tokenization_llama.py#L189",returnDescription:`
<p>A list of integers in the range [0, 1]: 1 for a special token, 0 for a sequence token.</p>
`,returnType:`
<p><code>List[int]</code></p>
`}}),Qe=new C({props:{name:"create_token_type_ids_from_sequences",anchor:"transformers.LlamaTokenizer.create_token_type_ids_from_sequences",parameters:[{name:"token_ids_0",val:": typing.List[int]"},{name:"token_ids_1",val:": typing.Optional[typing.List[int]] = None"}],parametersDescription:[{anchor:"transformers.LlamaTokenizer.create_token_type_ids_from_sequences.token_ids_0",description:`<strong>token_ids_0</strong> (<code>List[int]</code>) &#x2014;
List of ids.`,name:"token_ids_0"},{anchor:"transformers.LlamaTokenizer.create_token_type_ids_from_sequences.token_ids_1",description:`<strong>token_ids_1</strong> (<code>List[int]</code>, <em>optional</em>) &#x2014;
Optional second list of IDs for sequence pairs.`,name:"token_ids_1"}],source:"https://github.com/huggingface/transformers/blob/vr_21990/src/transformers/models/llama/tokenization_llama.py#L226",returnDescription:`
<p>List of <a href="../glossary#token-type-ids">token type IDs</a> according to the given sequence(s).</p>
`,returnType:`
<p><code>List[int]</code></p>
`}}),fe=new jn({props:{anchor:"transformers.LlamaTokenizer.create_token_type_ids_from_sequences.example",$$slots:{default:[pl]},$$scope:{ctx:x}}}),Ye=new C({props:{name:"save_vocabulary",anchor:"transformers.LlamaTokenizer.save_vocabulary",parameters:[{name:"save_directory",val:""},{name:"filename_prefix",val:": typing.Optional[str] = None"}],parametersDescription:[{anchor:"transformers.LlamaTokenizer.save_vocabulary.save_directory",description:`<strong>save_directory</strong> (<code>str</code>) &#x2014;
The directory in which to save the vocabulary.`,name:"save_directory"}],source:"https://github.com/huggingface/transformers/blob/vr_21990/src/transformers/models/llama/tokenization_llama.py#L151",returnDescription:`
<p>Paths to the files saved.</p>
`,returnType:`
<p><code>Tuple(str)</code></p>
`}}),et=new Ce({}),tt=new C({props:{name:"class transformers.LlamaTokenizerFast",anchor:"transformers.LlamaTokenizerFast",parameters:[{name:"vocab_file",val:" = None"},{name:"tokenizer_file",val:" = None"},{name:"clean_up_tokenization_spaces",val:" = False"},{name:"unk_token",val:" = '<unk>'"},{name:"bos_token",val:" = '<s>'"},{name:"eos_token",val:" = '</s>'"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.LlamaTokenizerFast.vocab_file",description:`<strong>vocab_file</strong> (<code>str</code>) &#x2014;
<a href="https://github.com/google/sentencepiece" rel="nofollow">SentencePiece</a> file (generally has a .model extension) that
contains the vocabulary necessary to instantiate a tokenizer.`,name:"vocab_file"},{anchor:"transformers.LlamaTokenizerFast.tokenizer_file",description:`<strong>tokenizer_file</strong> (<code>str</code>) &#x2014;
<a href="https://github.com/huggingface/tokenizers" rel="nofollow">tokenizers</a> file (generally has a .json extension) that
contains everything needed to load the tokenizer.`,name:"tokenizer_file"},{anchor:"transformers.LlamaTokenizerFast.clean_up_tokenization_spaces",description:`<strong>clean_up_tokenization_spaces</strong> (<code>str</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Wether to cleanup spaces after decoding, cleanup consists in removing potential artifacts like extra
spaces.`,name:"clean_up_tokenization_spaces"},{anchor:"transformers.LlamaTokenizerFast.bos_token",description:`<strong>bos_token</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;&lt;s&gt;&quot;</code>) &#x2014;
The beginning of sequence token that was used during pretraining. Can be used a sequence classifier token.`,name:"bos_token"},{anchor:"transformers.LlamaTokenizerFast.eos_token",description:`<strong>eos_token</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;&lt;/s&gt;&quot;</code>) &#x2014;
The end of sequence token.`,name:"eos_token"},{anchor:"transformers.LlamaTokenizerFast.unk_token",description:`<strong>unk_token</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;&lt;unk&gt;&quot;</code>) &#x2014;
The unknown token. A token that is not in the vocabulary cannot be converted to an ID and is set to be this
token instead.`,name:"unk_token"}],source:"https://github.com/huggingface/transformers/blob/vr_21990/src/transformers/models/llama/tokenization_llama_fast.py#L35"}}),ge=new jn({props:{anchor:"transformers.LlamaTokenizerFast.example",$$slots:{default:[hl]},$$scope:{ctx:x}}}),nt=new C({props:{name:"build_inputs_with_special_tokens",anchor:"transformers.LlamaTokenizerFast.build_inputs_with_special_tokens",parameters:[{name:"token_ids_0",val:": typing.List[int]"},{name:"token_ids_1",val:": typing.Optional[typing.List[int]] = None"}],parametersDescription:[{anchor:"transformers.LlamaTokenizerFast.build_inputs_with_special_tokens.token_ids_0",description:"<strong>token_ids_0</strong> (<code>List[int]</code>) &#x2014; The first tokenized sequence.",name:"token_ids_0"},{anchor:"transformers.LlamaTokenizerFast.build_inputs_with_special_tokens.token_ids_1",description:"<strong>token_ids_1</strong> (<code>List[int]</code>, <em>optional</em>) &#x2014; The second tokenized sequence.",name:"token_ids_1"}],source:"https://github.com/huggingface/transformers/blob/vr_21990/src/transformers/tokenization_utils_base.py#L3067",returnDescription:`
<p>The model input with special tokens.</p>
`,returnType:`
<p><code>List[int]</code></p>
`}}),at=new C({props:{name:"get_special_tokens_mask",anchor:"transformers.LlamaTokenizerFast.get_special_tokens_mask",parameters:[{name:"token_ids_0",val:": typing.List[int]"},{name:"token_ids_1",val:": typing.Optional[typing.List[int]] = None"},{name:"already_has_special_tokens",val:": bool = False"}],parametersDescription:[{anchor:"transformers.LlamaTokenizerFast.get_special_tokens_mask.token_ids_0",description:`<strong>token_ids_0</strong> (<code>List[int]</code>) &#x2014;
List of ids of the first sequence.`,name:"token_ids_0"},{anchor:"transformers.LlamaTokenizerFast.get_special_tokens_mask.token_ids_1",description:`<strong>token_ids_1</strong> (<code>List[int]</code>, <em>optional</em>) &#x2014;
List of ids of the second sequence.`,name:"token_ids_1"},{anchor:"transformers.LlamaTokenizerFast.get_special_tokens_mask.already_has_special_tokens",description:`<strong>already_has_special_tokens</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not the token list is already formatted with special tokens for the model.`,name:"already_has_special_tokens"}],source:"https://github.com/huggingface/transformers/blob/vr_21990/src/transformers/tokenization_utils_base.py#L3512",returnDescription:`
<p>1 for a special token, 0 for a sequence token.</p>
`,returnType:`
<p>A list of integers in the range [0, 1]</p>
`}}),st=new C({props:{name:"create_token_type_ids_from_sequences",anchor:"transformers.LlamaTokenizerFast.create_token_type_ids_from_sequences",parameters:[{name:"token_ids_0",val:": typing.List[int]"},{name:"token_ids_1",val:": typing.Optional[typing.List[int]] = None"}],parametersDescription:[{anchor:"transformers.LlamaTokenizerFast.create_token_type_ids_from_sequences.token_ids_0",description:"<strong>token_ids_0</strong> (<code>List[int]</code>) &#x2014; The first tokenized sequence.",name:"token_ids_0"},{anchor:"transformers.LlamaTokenizerFast.create_token_type_ids_from_sequences.token_ids_1",description:"<strong>token_ids_1</strong> (<code>List[int]</code>, <em>optional</em>) &#x2014; The second tokenized sequence.",name:"token_ids_1"}],source:"https://github.com/huggingface/transformers/blob/vr_21990/src/transformers/tokenization_utils_base.py#L3047",returnDescription:`
<p>The token type ids.</p>
`,returnType:`
<p><code>List[int]</code></p>
`}}),rt=new C({props:{name:"save_vocabulary",anchor:"transformers.LlamaTokenizerFast.save_vocabulary",parameters:[{name:"save_directory",val:": str"},{name:"filename_prefix",val:": typing.Optional[str] = None"}],source:"https://github.com/huggingface/transformers/blob/vr_21990/src/transformers/models/llama/tokenization_llama_fast.py#L102"}}),it=new Ce({}),lt=new C({props:{name:"class transformers.LlamaModel",anchor:"transformers.LlamaModel",parameters:[{name:"config",val:": LlamaConfig"}],parametersDescription:[{anchor:"transformers.LlamaModel.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_21990/en/model_doc/llama#transformers.LlamaConfig">LlamaConfig</a>) &#x2014;
Model configuration class with all the parameters of the model. Initializing with a config file does not
load the weights associated with the model, only the configuration. Check out the
<a href="/docs/transformers/pr_21990/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.
config &#x2014; LlamaConfig`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_21990/src/transformers/models/llama/modeling_llama.py#L432"}}),pt=new C({props:{name:"forward",anchor:"transformers.LlamaModel.forward",parameters:[{name:"input_ids",val:": LongTensor = None"},{name:"attention_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"position_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"past_key_values",val:": typing.Optional[typing.List[torch.FloatTensor]] = None"},{name:"inputs_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"use_cache",val:": typing.Optional[bool] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.LlamaModel.forward.input_ids",description:`<strong>input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary. Padding will be ignored by default should you provide
it.</p>
<p>Indices can be obtained using <a href="/docs/transformers/pr_21990/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/pr_21990/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/pr_21990/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.LlamaModel.forward.attention_mask",description:`<strong>attention_mask</strong> (<code>torch.Tensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a></p>
<p>Indices can be obtained using <a href="/docs/transformers/pr_21990/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/pr_21990/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/pr_21990/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p>If <code>past_key_values</code> is used, optionally only the last <code>decoder_input_ids</code> have to be input (see
<code>past_key_values</code>).</p>
<p>If you want to change padding behavior, you should read <code>modeling_opt._prepare_decoder_attention_mask</code>
and modify to your needs. See diagram 1 in <a href="https://arxiv.org/abs/1910.13461" rel="nofollow">the paper</a> for more
information on the default strategy.</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"attention_mask"},{anchor:"transformers.LlamaModel.forward.position_ids",description:`<strong>position_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of positions of each input sequence tokens in the position embeddings. Selected in the range <code>[0, config.n_positions - 1]</code>.</p>
<p><a href="../glossary#position-ids">What are position IDs?</a>`,name:"position_ids"},{anchor:"transformers.LlamaModel.forward.past_key_values",description:`<strong>past_key_values</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>use_cache=True</code> is passed or when <code>config.use_cache=True</code>) &#x2014;
Tuple of <code>tuple(torch.FloatTensor)</code> of length <code>config.n_layers</code>, with each tuple having 2 tensors of shape
<code>(batch_size, num_heads, sequence_length, embed_size_per_head)</code>) and 2 additional tensors of shape
<code>(batch_size, num_heads, encoder_sequence_length, embed_size_per_head)</code>.</p>
<p>Contains pre-computed hidden-states (key and values in the self-attention blocks and in the cross-attention
blocks) that can be used (see <code>past_key_values</code> input) to speed up sequential decoding.</p>
<p>If <code>past_key_values</code> are used, the user can optionally input only the last <code>decoder_input_ids</code> (those that
don&#x2019;t have their past key value states given to this model) of shape <code>(batch_size, 1)</code> instead of all
<code>decoder_input_ids</code> of shape <code>(batch_size, sequence_length)</code>.`,name:"past_key_values"},{anchor:"transformers.LlamaModel.forward.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>input_ids</code> you can choose to directly pass an embedded representation. This
is useful if you want more control over how to convert <code>input_ids</code> indices into associated vectors than the
model&#x2019;s internal embedding lookup matrix.`,name:"inputs_embeds"},{anchor:"transformers.LlamaModel.forward.use_cache",description:`<strong>use_cache</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
If set to <code>True</code>, <code>past_key_values</code> key value states are returned and can be used to speed up decoding (see
<code>past_key_values</code>).`,name:"use_cache"},{anchor:"transformers.LlamaModel.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.LlamaModel.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.LlamaModel.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_21990/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/vr_21990/src/transformers/models/llama/modeling_llama.py#L483"}}),ye=new Br({props:{$$slots:{default:[fl]},$$scope:{ctx:x}}}),ht=new Ce({}),ft=new C({props:{name:"class transformers.LlamaForCausalLM",anchor:"transformers.LlamaForCausalLM",parameters:[{name:"config",val:""}],source:"https://github.com/huggingface/transformers/blob/vr_21990/src/transformers/models/llama/modeling_llama.py#L612"}}),ut=new C({props:{name:"forward",anchor:"transformers.LlamaForCausalLM.forward",parameters:[{name:"input_ids",val:": LongTensor = None"},{name:"attention_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"position_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"past_key_values",val:": typing.Optional[typing.List[torch.FloatTensor]] = None"},{name:"inputs_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"labels",val:": typing.Optional[torch.LongTensor] = None"},{name:"use_cache",val:": typing.Optional[bool] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.LlamaForCausalLM.forward.input_ids",description:`<strong>input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary. Padding will be ignored by default should you provide
it.</p>
<p>Indices can be obtained using <a href="/docs/transformers/pr_21990/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/pr_21990/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/pr_21990/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.LlamaForCausalLM.forward.attention_mask",description:`<strong>attention_mask</strong> (<code>torch.Tensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a></p>
<p>Indices can be obtained using <a href="/docs/transformers/pr_21990/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/pr_21990/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/pr_21990/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p>If <code>past_key_values</code> is used, optionally only the last <code>decoder_input_ids</code> have to be input (see
<code>past_key_values</code>).</p>
<p>If you want to change padding behavior, you should read <code>modeling_opt._prepare_decoder_attention_mask</code>
and modify to your needs. See diagram 1 in <a href="https://arxiv.org/abs/1910.13461" rel="nofollow">the paper</a> for more
information on the default strategy.</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"attention_mask"},{anchor:"transformers.LlamaForCausalLM.forward.position_ids",description:`<strong>position_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of positions of each input sequence tokens in the position embeddings. Selected in the range <code>[0, config.n_positions - 1]</code>.</p>
<p><a href="../glossary#position-ids">What are position IDs?</a>`,name:"position_ids"},{anchor:"transformers.LlamaForCausalLM.forward.past_key_values",description:`<strong>past_key_values</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>use_cache=True</code> is passed or when <code>config.use_cache=True</code>) &#x2014;
Tuple of <code>tuple(torch.FloatTensor)</code> of length <code>config.n_layers</code>, with each tuple having 2 tensors of shape
<code>(batch_size, num_heads, sequence_length, embed_size_per_head)</code>) and 2 additional tensors of shape
<code>(batch_size, num_heads, encoder_sequence_length, embed_size_per_head)</code>.</p>
<p>Contains pre-computed hidden-states (key and values in the self-attention blocks and in the cross-attention
blocks) that can be used (see <code>past_key_values</code> input) to speed up sequential decoding.</p>
<p>If <code>past_key_values</code> are used, the user can optionally input only the last <code>decoder_input_ids</code> (those that
don&#x2019;t have their past key value states given to this model) of shape <code>(batch_size, 1)</code> instead of all
<code>decoder_input_ids</code> of shape <code>(batch_size, sequence_length)</code>.`,name:"past_key_values"},{anchor:"transformers.LlamaForCausalLM.forward.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>input_ids</code> you can choose to directly pass an embedded representation. This
is useful if you want more control over how to convert <code>input_ids</code> indices into associated vectors than the
model&#x2019;s internal embedding lookup matrix.`,name:"inputs_embeds"},{anchor:"transformers.LlamaForCausalLM.forward.use_cache",description:`<strong>use_cache</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
If set to <code>True</code>, <code>past_key_values</code> key value states are returned and can be used to speed up decoding (see
<code>past_key_values</code>).`,name:"use_cache"},{anchor:"transformers.LlamaForCausalLM.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.LlamaForCausalLM.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.LlamaForCausalLM.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_21990/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.</p>
<p>Args &#x2014;
labels (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>):
Labels for computing the masked language modeling loss. Indices should either be in <code>[0, ..., config.vocab_size]</code> or -100 (see <code>input_ids</code> docstring). Tokens with indices set to <code>-100</code> are ignored
(masked), the loss is only computed for the tokens with labels in <code>[0, ..., config.vocab_size]</code>.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/vr_21990/src/transformers/models/llama/modeling_llama.py#L640",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_21990/en/main_classes/output#transformers.modeling_outputs.CausalLMOutputWithPast"
>transformers.modeling_outputs.CausalLMOutputWithPast</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/pr_21990/en/model_doc/llama#transformers.LlamaConfig"
>LlamaConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>loss</strong> (<code>torch.FloatTensor</code> of shape <code>(1,)</code>, <em>optional</em>, returned when <code>labels</code> is provided) \u2014 Language modeling loss (for next-token prediction).</p>
</li>
<li>
<p><strong>logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, config.vocab_size)</code>) \u2014 Prediction scores of the language modeling head (scores for each vocabulary token before SoftMax).</p>
</li>
<li>
<p><strong>past_key_values</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>use_cache=True</code> is passed or when <code>config.use_cache=True</code>) \u2014 Tuple of <code>tuple(torch.FloatTensor)</code> of length <code>config.n_layers</code>, with each tuple having 2 tensors of shape
<code>(batch_size, num_heads, sequence_length, embed_size_per_head)</code>)</p>
<p>Contains pre-computed hidden-states (key and values in the self-attention blocks) that can be used (see
<code>past_key_values</code> input) to speed up sequential decoding.</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings, if the model has an embedding layer, +
one for the output of each layer) of shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the optional initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_21990/en/main_classes/output#transformers.modeling_outputs.CausalLMOutputWithPast"
>transformers.modeling_outputs.CausalLMOutputWithPast</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),$e=new Br({props:{$$slots:{default:[ul]},$$scope:{ctx:x}}}),Te=new jn({props:{anchor:"transformers.LlamaForCausalLM.forward.example",$$slots:{default:[_l]},$$scope:{ctx:x}}}),_t=new Ce({}),gt=new C({props:{name:"class transformers.LlamaForSequenceClassification",anchor:"transformers.LlamaForSequenceClassification",parameters:[{name:"config",val:""}],parametersDescription:[{anchor:"transformers.LlamaForSequenceClassification.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_21990/en/model_doc/llama#transformers.LlamaConfig">LlamaConfig</a>) &#x2014;
Model configuration class with all the parameters of the model. Initializing with a config file does not
load the weights associated with the model, only the configuration. Check out the
<a href="/docs/transformers/pr_21990/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_21990/src/transformers/models/llama/modeling_llama.py#L781"}}),yt=new C({props:{name:"forward",anchor:"transformers.LlamaForSequenceClassification.forward",parameters:[{name:"input_ids",val:": LongTensor = None"},{name:"attention_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"position_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"past_key_values",val:": typing.Optional[typing.List[torch.FloatTensor]] = None"},{name:"inputs_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"labels",val:": typing.Optional[torch.LongTensor] = None"},{name:"use_cache",val:": typing.Optional[bool] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.LlamaForSequenceClassification.forward.input_ids",description:`<strong>input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary. Padding will be ignored by default should you provide
it.</p>
<p>Indices can be obtained using <a href="/docs/transformers/pr_21990/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/pr_21990/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/pr_21990/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.LlamaForSequenceClassification.forward.attention_mask",description:`<strong>attention_mask</strong> (<code>torch.Tensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a></p>
<p>Indices can be obtained using <a href="/docs/transformers/pr_21990/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/pr_21990/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/pr_21990/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p>If <code>past_key_values</code> is used, optionally only the last <code>decoder_input_ids</code> have to be input (see
<code>past_key_values</code>).</p>
<p>If you want to change padding behavior, you should read <code>modeling_opt._prepare_decoder_attention_mask</code>
and modify to your needs. See diagram 1 in <a href="https://arxiv.org/abs/1910.13461" rel="nofollow">the paper</a> for more
information on the default strategy.</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"attention_mask"},{anchor:"transformers.LlamaForSequenceClassification.forward.position_ids",description:`<strong>position_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of positions of each input sequence tokens in the position embeddings. Selected in the range <code>[0, config.n_positions - 1]</code>.</p>
<p><a href="../glossary#position-ids">What are position IDs?</a>`,name:"position_ids"},{anchor:"transformers.LlamaForSequenceClassification.forward.past_key_values",description:`<strong>past_key_values</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>use_cache=True</code> is passed or when <code>config.use_cache=True</code>) &#x2014;
Tuple of <code>tuple(torch.FloatTensor)</code> of length <code>config.n_layers</code>, with each tuple having 2 tensors of shape
<code>(batch_size, num_heads, sequence_length, embed_size_per_head)</code>) and 2 additional tensors of shape
<code>(batch_size, num_heads, encoder_sequence_length, embed_size_per_head)</code>.</p>
<p>Contains pre-computed hidden-states (key and values in the self-attention blocks and in the cross-attention
blocks) that can be used (see <code>past_key_values</code> input) to speed up sequential decoding.</p>
<p>If <code>past_key_values</code> are used, the user can optionally input only the last <code>decoder_input_ids</code> (those that
don&#x2019;t have their past key value states given to this model) of shape <code>(batch_size, 1)</code> instead of all
<code>decoder_input_ids</code> of shape <code>(batch_size, sequence_length)</code>.`,name:"past_key_values"},{anchor:"transformers.LlamaForSequenceClassification.forward.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>input_ids</code> you can choose to directly pass an embedded representation. This
is useful if you want more control over how to convert <code>input_ids</code> indices into associated vectors than the
model&#x2019;s internal embedding lookup matrix.`,name:"inputs_embeds"},{anchor:"transformers.LlamaForSequenceClassification.forward.use_cache",description:`<strong>use_cache</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
If set to <code>True</code>, <code>past_key_values</code> key value states are returned and can be used to speed up decoding (see
<code>past_key_values</code>).`,name:"use_cache"},{anchor:"transformers.LlamaForSequenceClassification.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.LlamaForSequenceClassification.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.LlamaForSequenceClassification.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_21990/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"},{anchor:"transformers.LlamaForSequenceClassification.forward.labels",description:`<strong>labels</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size,)</code>, <em>optional</em>) &#x2014;
Labels for computing the sequence classification/regression loss. Indices should be in <code>[0, ..., config.num_labels - 1]</code>. If <code>config.num_labels == 1</code> a regression loss is computed (Mean-Square loss), If
<code>config.num_labels &gt; 1</code> a classification loss is computed (Cross-Entropy).`,name:"labels"}],source:"https://github.com/huggingface/transformers/blob/vr_21990/src/transformers/models/llama/modeling_llama.py#L799"}}),ze=new Br({props:{$$slots:{default:[gl]},$$scope:{ctx:x}}}),{c(){p=n("meta"),T=d(),h=n("h1"),_=n("a"),w=n("span"),k(f.$$.fragment),g=d(),P=n("span"),Wn=r("LLaMA"),Uo=d(),X=n("h2"),ie=n("a"),oo=n("span"),k(xe.$$.fragment),Hn=d(),no=n("span"),Rn=r("Overview"),Xo=d(),le=n("p"),Gn=r("The LLaMA model was proposed in "),qe=n("a"),Vn=r("LLaMA: Open and Efficient Foundation Language Models"),Un=r(" by Hugo Touvron, Thibaut Lavril, Gautier Izacard, Xavier Martinet, Marie-Anne Lachaux, Timoth\xE9e Lacroix, Baptiste Rozi\xE8re, Naman Goyal, Eric Hambro, Faisal Azhar, Aurelien Rodriguez, Armand Joulin, Edouard Grave, Guillaume Lample. It is a collection of foundation language models ranging from 7B to 65B parameters."),Jo=d(),Tt=n("p"),Xn=r("The abstract from the paper is the following:"),Ko=d(),wt=n("p"),ao=n("em"),Jn=r("We introduce LLaMA, a collection of foundation language models ranging from 7B to 65B parameters. We train our models on trillions of tokens, and show that it is possible to train state-of-the-art models using publicly available datasets exclusively, without resorting to proprietary and inaccessible datasets. In particular, LLaMA-13B outperforms GPT-3 (175B) on most benchmarks, and LLaMA-65B is competitive with the best models, Chinchilla-70B and PaLM-540B. We release all our models to the research community."),Zo=d(),zt=n("p"),Kn=r("Tips:"),Qo=d(),de=n("ul"),Et=n("li"),Zn=r("Weights for the LLaMA models can be obtained from by filling out "),Pe=n("a"),Qn=r("this form"),Yn=d(),Ae=n("li"),ea=r("After downloading the weights, they will need to be converted to the Hugging Face Transformers format using the "),Ie=n("a"),ta=r("conversion script"),oa=r(". The script can be called with the following (example) command:"),Yo=d(),k(Oe.$$.fragment),en=d(),Mt=n("ul"),so=n("li"),na=r("After conversion, the model and tokenizer can be loaded via:"),tn=d(),k(Se.$$.fragment),on=d(),Ft=n("p"),aa=r(`Note that executing the script requires enough CPU RAM to host the whole model in float16 precision (even if the biggest versions
come in several checkpoints they each contain a part of each weight of the model, so we need to load them all in RAM). For the 65B model, it\u2019s thus 130GB of RAM needed.`),nn=d(),Ct=n("ul"),De=n("li"),sa=r("The LLaMA tokenizer is a BPE model based on "),Ne=n("a"),ra=r("sentencepiece"),ia=r(". One quirk of sentencepiece is that when decoding a sequence, if the first token is the start of the word (e.g. \u201CBanana\u201D), the tokenizer does not prepend the prefix space to the string."),an=d(),A=n("p"),la=r("This model was contributed by "),je=n("a"),da=r("zphang"),ca=r(" with contributions from "),Be=n("a"),ma=r("BlackSamorez"),pa=r(". The code of the implementation in Hugging Face is based on GPT-NeoX "),We=n("a"),ha=r("here"),fa=r(". The original code of the authors can be found "),He=n("a"),ua=r("here"),_a=r("."),sn=d(),J=n("h2"),ce=n("a"),ro=n("span"),k(Re.$$.fragment),ga=d(),io=n("span"),ka=r("LlamaConfig"),rn=d(),O=n("div"),k(Ge.$$.fragment),va=d(),Ve=n("p"),ba=r("This is the configuration class to store the configuration of a "),xt=n("a"),ya=r("LlamaModel"),La=r(`. It is used to instantiate an LLaMA
model according to the specified arguments, defining the model architecture. Instantiating a configuration with the
defaults will yield a similar configuration to that of the LLaMA-7B.`),$a=d(),K=n("p"),Ta=r("Configuration objects inherit from "),qt=n("a"),wa=r("PretrainedConfig"),za=r(` and can be used to control the model outputs. Read the
documentation from `),Pt=n("a"),Ea=r("PretrainedConfig"),Ma=r(" for more information."),Fa=d(),k(me.$$.fragment),ln=d(),Z=n("h2"),pe=n("a"),lo=n("span"),k(Ue.$$.fragment),Ca=d(),co=n("span"),xa=r("LlamaTokenizer"),dn=d(),F=n("div"),k(Xe.$$.fragment),qa=d(),mo=n("p"),Pa=r("Construct a Llama tokenizer. Based on byte-level Byte-Pair-Encoding."),Aa=d(),At=n("div"),k(Je.$$.fragment),Ia=d(),he=n("div"),k(Ke.$$.fragment),Oa=d(),Ze=n("p"),Sa=r(`Retrieve sequence ids from a token list that has no special tokens added. This method is called when adding
special tokens using the tokenizer `),po=n("code"),Da=r("prepare_for_model"),Na=r(" method."),ja=d(),D=n("div"),k(Qe.$$.fragment),Ba=d(),ho=n("p"),Wa=r("Creates a mask from the two sequences passed to be used in a sequence-pair classification task. An ALBERT"),Ha=d(),k(fe.$$.fragment),Ra=d(),fo=n("p"),Ga=r("if token_ids_1 is None, only returns the first portion of the mask (0s)."),Va=d(),ue=n("div"),k(Ye.$$.fragment),Ua=d(),uo=n("p"),Xa=r("Save the vocabulary and special tokens file to a directory."),cn=d(),Q=n("h2"),_e=n("a"),_o=n("span"),k(et.$$.fragment),Ja=d(),go=n("span"),Ka=r("LlamaTokenizerFast"),mn=d(),z=n("div"),k(tt.$$.fragment),Za=d(),ko=n("p"),Qa=r("Construct a Llama tokenizer. Based on byte-level Byte-Pair-Encoding."),Ya=d(),vo=n("p"),es=r("This uses notably ByteFallback and no normalization."),ts=d(),k(ge.$$.fragment),os=d(),ot=n("p"),ns=r("This tokenizer inherits from "),It=n("a"),as=r("PreTrainedTokenizerFast"),ss=r(` which contains most of the main methods. Users should
refer to this superclass for more information regarding those methods.`),rs=d(),B=n("div"),k(nt.$$.fragment),is=d(),bo=n("p"),ls=r(`Build model inputs from a sequence or a pair of sequence for sequence classification tasks by concatenating and
adding special tokens.`),ds=d(),yo=n("p"),cs=r("This implementation does not add special tokens and this method should be overridden in a subclass."),ms=d(),ke=n("div"),k(at.$$.fragment),ps=d(),Y=n("p"),hs=r(`Retrieves sequence ids from a token list that has no special tokens added. This method is called when adding
special tokens using the tokenizer `),Lo=n("code"),fs=r("prepare_for_model"),us=r(" or "),$o=n("code"),_s=r("encode_plus"),gs=r(" methods."),ks=d(),W=n("div"),k(st.$$.fragment),vs=d(),Ot=n("p"),bs=r("Create the token type IDs corresponding to the sequences passed. "),St=n("a"),ys=r(`What are token type
IDs?`),Ls=d(),To=n("p"),$s=r("Should be overridden in a subclass if the model has a special way of building those."),Ts=d(),Dt=n("div"),k(rt.$$.fragment),pn=d(),ee=n("h2"),ve=n("a"),wo=n("span"),k(it.$$.fragment),ws=d(),zo=n("span"),zs=r("LlamaModel"),hn=d(),q=n("div"),k(lt.$$.fragment),Es=d(),dt=n("p"),Ms=r(`The bare LLaMA Model outputting raw hidden-states without any specific head on top.
This model inherits from `),Nt=n("a"),Fs=r("PreTrainedModel"),Cs=r(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),xs=d(),ct=n("p"),qs=r("This model is also a PyTorch "),mt=n("a"),Ps=r("torch.nn.Module"),As=r(` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),Is=d(),be=n("p"),Os=r("Transformer decoder consisting of "),Eo=n("em"),Ss=r("config.num_hidden_layers"),Ds=r(" layers. Each layer is a "),Mo=n("code"),Ns=r("LlamaDecoderLayer"),js=d(),H=n("div"),k(pt.$$.fragment),Bs=d(),te=n("p"),Ws=r("The "),jt=n("a"),Hs=r("LlamaModel"),Rs=r(" forward method, overrides the "),Fo=n("code"),Gs=r("__call__"),Vs=r(" special method."),Us=d(),k(ye.$$.fragment),fn=d(),oe=n("h2"),Le=n("a"),Co=n("span"),k(ht.$$.fragment),Xs=d(),xo=n("span"),Js=r("LlamaForCausalLM"),un=d(),ne=n("div"),k(ft.$$.fragment),Ks=d(),N=n("div"),k(ut.$$.fragment),Zs=d(),ae=n("p"),Qs=r("The "),Bt=n("a"),Ys=r("LlamaForCausalLM"),er=r(" forward method, overrides the "),qo=n("code"),tr=r("__call__"),or=r(" special method."),nr=d(),k($e.$$.fragment),ar=d(),k(Te.$$.fragment),_n=d(),se=n("h2"),we=n("a"),Po=n("span"),k(_t.$$.fragment),sr=d(),Ao=n("span"),rr=r("LlamaForSequenceClassification"),gn=d(),E=n("div"),k(gt.$$.fragment),ir=d(),Io=n("p"),lr=r("The LLaMa Model transformer with a sequence classification head on top (linear layer)."),dr=d(),Wt=n("p"),Ht=n("a"),cr=r("LlamaForSequenceClassification"),mr=r(` uses the last token in order to do the classification, as other causal models
(e.g. GPT-2) do.`),pr=d(),S=n("p"),hr=r(`Since it does classification on the last token, it requires to know the position of the last token. If a
`),Oo=n("code"),fr=r("pad_token_id"),ur=r(` is defined in the configuration, it finds the last token that is not a padding token in each row. If
no `),So=n("code"),_r=r("pad_token_id"),gr=r(` is defined, it simply takes the last value in each row of the batch. Since it cannot guess the
padding tokens when `),Do=n("code"),kr=r("inputs_embeds"),vr=r(" are passed instead of "),No=n("code"),br=r("input_ids"),yr=r(`, it does the same (take the last value in
each row of the batch).`),Lr=d(),kt=n("p"),$r=r("This model inherits from "),Rt=n("a"),Tr=r("PreTrainedModel"),wr=r(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),zr=d(),vt=n("p"),Er=r("This model is also a PyTorch "),bt=n("a"),Mr=r("torch.nn.Module"),Fr=r(` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),Cr=d(),R=n("div"),k(yt.$$.fragment),xr=d(),re=n("p"),qr=r("The "),Gt=n("a"),Pr=r("LlamaForSequenceClassification"),Ar=r(" forward method, overrides the "),jo=n("code"),Ir=r("__call__"),Or=r(" special method."),Sr=d(),k(ze.$$.fragment),this.h()},l(t){const m=dl('[data-svelte="svelte-1phssyn"]',document.head);p=a(m,"META",{name:!0,content:!0}),m.forEach(o),T=c(t),h=a(t,"H1",{class:!0});var Lt=s(h);_=a(Lt,"A",{id:!0,class:!0,href:!0});var Bo=s(_);w=a(Bo,"SPAN",{});var Wo=s(w);v(f.$$.fragment,Wo),Wo.forEach(o),Bo.forEach(o),g=c(Lt),P=a(Lt,"SPAN",{});var Ho=s(P);Wn=i(Ho,"LLaMA"),Ho.forEach(o),Lt.forEach(o),Uo=c(t),X=a(t,"H2",{class:!0});var $t=s(X);ie=a($t,"A",{id:!0,class:!0,href:!0});var Ro=s(ie);oo=a(Ro,"SPAN",{});var Go=s(oo);v(xe.$$.fragment,Go),Go.forEach(o),Ro.forEach(o),Hn=c($t),no=a($t,"SPAN",{});var Wr=s(no);Rn=i(Wr,"Overview"),Wr.forEach(o),$t.forEach(o),Xo=c(t),le=a(t,"P",{});var vn=s(le);Gn=i(vn,"The LLaMA model was proposed in "),qe=a(vn,"A",{href:!0,rel:!0});var Hr=s(qe);Vn=i(Hr,"LLaMA: Open and Efficient Foundation Language Models"),Hr.forEach(o),Un=i(vn," by Hugo Touvron, Thibaut Lavril, Gautier Izacard, Xavier Martinet, Marie-Anne Lachaux, Timoth\xE9e Lacroix, Baptiste Rozi\xE8re, Naman Goyal, Eric Hambro, Faisal Azhar, Aurelien Rodriguez, Armand Joulin, Edouard Grave, Guillaume Lample. It is a collection of foundation language models ranging from 7B to 65B parameters."),vn.forEach(o),Jo=c(t),Tt=a(t,"P",{});var Rr=s(Tt);Xn=i(Rr,"The abstract from the paper is the following:"),Rr.forEach(o),Ko=c(t),wt=a(t,"P",{});var Gr=s(wt);ao=a(Gr,"EM",{});var Vr=s(ao);Jn=i(Vr,"We introduce LLaMA, a collection of foundation language models ranging from 7B to 65B parameters. We train our models on trillions of tokens, and show that it is possible to train state-of-the-art models using publicly available datasets exclusively, without resorting to proprietary and inaccessible datasets. In particular, LLaMA-13B outperforms GPT-3 (175B) on most benchmarks, and LLaMA-65B is competitive with the best models, Chinchilla-70B and PaLM-540B. We release all our models to the research community."),Vr.forEach(o),Gr.forEach(o),Zo=c(t),zt=a(t,"P",{});var Ur=s(zt);Kn=i(Ur,"Tips:"),Ur.forEach(o),Qo=c(t),de=a(t,"UL",{});var bn=s(de);Et=a(bn,"LI",{});var Dr=s(Et);Zn=i(Dr,"Weights for the LLaMA models can be obtained from by filling out "),Pe=a(Dr,"A",{href:!0,rel:!0});var Xr=s(Pe);Qn=i(Xr,"this form"),Xr.forEach(o),Dr.forEach(o),Yn=c(bn),Ae=a(bn,"LI",{});var yn=s(Ae);ea=i(yn,"After downloading the weights, they will need to be converted to the Hugging Face Transformers format using the "),Ie=a(yn,"A",{href:!0,rel:!0});var Jr=s(Ie);ta=i(Jr,"conversion script"),Jr.forEach(o),oa=i(yn,". The script can be called with the following (example) command:"),yn.forEach(o),bn.forEach(o),Yo=c(t),v(Oe.$$.fragment,t),en=c(t),Mt=a(t,"UL",{});var Kr=s(Mt);so=a(Kr,"LI",{});var Zr=s(so);na=i(Zr,"After conversion, the model and tokenizer can be loaded via:"),Zr.forEach(o),Kr.forEach(o),tn=c(t),v(Se.$$.fragment,t),on=c(t),Ft=a(t,"P",{});var Qr=s(Ft);aa=i(Qr,`Note that executing the script requires enough CPU RAM to host the whole model in float16 precision (even if the biggest versions
come in several checkpoints they each contain a part of each weight of the model, so we need to load them all in RAM). For the 65B model, it\u2019s thus 130GB of RAM needed.`),Qr.forEach(o),nn=c(t),Ct=a(t,"UL",{});var Yr=s(Ct);De=a(Yr,"LI",{});var Ln=s(De);sa=i(Ln,"The LLaMA tokenizer is a BPE model based on "),Ne=a(Ln,"A",{href:!0,rel:!0});var ei=s(Ne);ra=i(ei,"sentencepiece"),ei.forEach(o),ia=i(Ln,". One quirk of sentencepiece is that when decoding a sequence, if the first token is the start of the word (e.g. \u201CBanana\u201D), the tokenizer does not prepend the prefix space to the string."),Ln.forEach(o),Yr.forEach(o),an=c(t),A=a(t,"P",{});var G=s(A);la=i(G,"This model was contributed by "),je=a(G,"A",{href:!0,rel:!0});var ti=s(je);da=i(ti,"zphang"),ti.forEach(o),ca=i(G," with contributions from "),Be=a(G,"A",{href:!0,rel:!0});var oi=s(Be);ma=i(oi,"BlackSamorez"),oi.forEach(o),pa=i(G,". The code of the implementation in Hugging Face is based on GPT-NeoX "),We=a(G,"A",{href:!0,rel:!0});var ni=s(We);ha=i(ni,"here"),ni.forEach(o),fa=i(G,". The original code of the authors can be found "),He=a(G,"A",{href:!0,rel:!0});var ai=s(He);ua=i(ai,"here"),ai.forEach(o),_a=i(G,"."),G.forEach(o),sn=c(t),J=a(t,"H2",{class:!0});var $n=s(J);ce=a($n,"A",{id:!0,class:!0,href:!0});var si=s(ce);ro=a(si,"SPAN",{});var ri=s(ro);v(Re.$$.fragment,ri),ri.forEach(o),si.forEach(o),ga=c($n),io=a($n,"SPAN",{});var ii=s(io);ka=i(ii,"LlamaConfig"),ii.forEach(o),$n.forEach(o),rn=c(t),O=a(t,"DIV",{class:!0});var Ee=s(O);v(Ge.$$.fragment,Ee),va=c(Ee),Ve=a(Ee,"P",{});var Tn=s(Ve);ba=i(Tn,"This is the configuration class to store the configuration of a "),xt=a(Tn,"A",{href:!0});var li=s(xt);ya=i(li,"LlamaModel"),li.forEach(o),La=i(Tn,`. It is used to instantiate an LLaMA
model according to the specified arguments, defining the model architecture. Instantiating a configuration with the
defaults will yield a similar configuration to that of the LLaMA-7B.`),Tn.forEach(o),$a=c(Ee),K=a(Ee,"P",{});var Vt=s(K);Ta=i(Vt,"Configuration objects inherit from "),qt=a(Vt,"A",{href:!0});var di=s(qt);wa=i(di,"PretrainedConfig"),di.forEach(o),za=i(Vt,` and can be used to control the model outputs. Read the
documentation from `),Pt=a(Vt,"A",{href:!0});var ci=s(Pt);Ea=i(ci,"PretrainedConfig"),ci.forEach(o),Ma=i(Vt," for more information."),Vt.forEach(o),Fa=c(Ee),v(me.$$.fragment,Ee),Ee.forEach(o),ln=c(t),Z=a(t,"H2",{class:!0});var wn=s(Z);pe=a(wn,"A",{id:!0,class:!0,href:!0});var mi=s(pe);lo=a(mi,"SPAN",{});var pi=s(lo);v(Ue.$$.fragment,pi),pi.forEach(o),mi.forEach(o),Ca=c(wn),co=a(wn,"SPAN",{});var hi=s(co);xa=i(hi,"LlamaTokenizer"),hi.forEach(o),wn.forEach(o),dn=c(t),F=a(t,"DIV",{class:!0});var j=s(F);v(Xe.$$.fragment,j),qa=c(j),mo=a(j,"P",{});var fi=s(mo);Pa=i(fi,"Construct a Llama tokenizer. Based on byte-level Byte-Pair-Encoding."),fi.forEach(o),Aa=c(j),At=a(j,"DIV",{class:!0});var ui=s(At);v(Je.$$.fragment,ui),ui.forEach(o),Ia=c(j),he=a(j,"DIV",{class:!0});var zn=s(he);v(Ke.$$.fragment,zn),Oa=c(zn),Ze=a(zn,"P",{});var En=s(Ze);Sa=i(En,`Retrieve sequence ids from a token list that has no special tokens added. This method is called when adding
special tokens using the tokenizer `),po=a(En,"CODE",{});var _i=s(po);Da=i(_i,"prepare_for_model"),_i.forEach(o),Na=i(En," method."),En.forEach(o),zn.forEach(o),ja=c(j),D=a(j,"DIV",{class:!0});var Me=s(D);v(Qe.$$.fragment,Me),Ba=c(Me),ho=a(Me,"P",{});var gi=s(ho);Wa=i(gi,"Creates a mask from the two sequences passed to be used in a sequence-pair classification task. An ALBERT"),gi.forEach(o),Ha=c(Me),v(fe.$$.fragment,Me),Ra=c(Me),fo=a(Me,"P",{});var ki=s(fo);Ga=i(ki,"if token_ids_1 is None, only returns the first portion of the mask (0s)."),ki.forEach(o),Me.forEach(o),Va=c(j),ue=a(j,"DIV",{class:!0});var Mn=s(ue);v(Ye.$$.fragment,Mn),Ua=c(Mn),uo=a(Mn,"P",{});var vi=s(uo);Xa=i(vi,"Save the vocabulary and special tokens file to a directory."),vi.forEach(o),Mn.forEach(o),j.forEach(o),cn=c(t),Q=a(t,"H2",{class:!0});var Fn=s(Q);_e=a(Fn,"A",{id:!0,class:!0,href:!0});var bi=s(_e);_o=a(bi,"SPAN",{});var yi=s(_o);v(et.$$.fragment,yi),yi.forEach(o),bi.forEach(o),Ja=c(Fn),go=a(Fn,"SPAN",{});var Li=s(go);Ka=i(Li,"LlamaTokenizerFast"),Li.forEach(o),Fn.forEach(o),mn=c(t),z=a(t,"DIV",{class:!0});var M=s(z);v(tt.$$.fragment,M),Za=c(M),ko=a(M,"P",{});var $i=s(ko);Qa=i($i,"Construct a Llama tokenizer. Based on byte-level Byte-Pair-Encoding."),$i.forEach(o),Ya=c(M),vo=a(M,"P",{});var Ti=s(vo);es=i(Ti,"This uses notably ByteFallback and no normalization."),Ti.forEach(o),ts=c(M),v(ge.$$.fragment,M),os=c(M),ot=a(M,"P",{});var Cn=s(ot);ns=i(Cn,"This tokenizer inherits from "),It=a(Cn,"A",{href:!0});var wi=s(It);as=i(wi,"PreTrainedTokenizerFast"),wi.forEach(o),ss=i(Cn,` which contains most of the main methods. Users should
refer to this superclass for more information regarding those methods.`),Cn.forEach(o),rs=c(M),B=a(M,"DIV",{class:!0});var Ut=s(B);v(nt.$$.fragment,Ut),is=c(Ut),bo=a(Ut,"P",{});var zi=s(bo);ls=i(zi,`Build model inputs from a sequence or a pair of sequence for sequence classification tasks by concatenating and
adding special tokens.`),zi.forEach(o),ds=c(Ut),yo=a(Ut,"P",{});var Ei=s(yo);cs=i(Ei,"This implementation does not add special tokens and this method should be overridden in a subclass."),Ei.forEach(o),Ut.forEach(o),ms=c(M),ke=a(M,"DIV",{class:!0});var xn=s(ke);v(at.$$.fragment,xn),ps=c(xn),Y=a(xn,"P",{});var Xt=s(Y);hs=i(Xt,`Retrieves sequence ids from a token list that has no special tokens added. This method is called when adding
special tokens using the tokenizer `),Lo=a(Xt,"CODE",{});var Mi=s(Lo);fs=i(Mi,"prepare_for_model"),Mi.forEach(o),us=i(Xt," or "),$o=a(Xt,"CODE",{});var Fi=s($o);_s=i(Fi,"encode_plus"),Fi.forEach(o),gs=i(Xt," methods."),Xt.forEach(o),xn.forEach(o),ks=c(M),W=a(M,"DIV",{class:!0});var Jt=s(W);v(st.$$.fragment,Jt),vs=c(Jt),Ot=a(Jt,"P",{});var Nr=s(Ot);bs=i(Nr,"Create the token type IDs corresponding to the sequences passed. "),St=a(Nr,"A",{href:!0});var Ci=s(St);ys=i(Ci,`What are token type
IDs?`),Ci.forEach(o),Nr.forEach(o),Ls=c(Jt),To=a(Jt,"P",{});var xi=s(To);$s=i(xi,"Should be overridden in a subclass if the model has a special way of building those."),xi.forEach(o),Jt.forEach(o),Ts=c(M),Dt=a(M,"DIV",{class:!0});var qi=s(Dt);v(rt.$$.fragment,qi),qi.forEach(o),M.forEach(o),pn=c(t),ee=a(t,"H2",{class:!0});var qn=s(ee);ve=a(qn,"A",{id:!0,class:!0,href:!0});var Pi=s(ve);wo=a(Pi,"SPAN",{});var Ai=s(wo);v(it.$$.fragment,Ai),Ai.forEach(o),Pi.forEach(o),ws=c(qn),zo=a(qn,"SPAN",{});var Ii=s(zo);zs=i(Ii,"LlamaModel"),Ii.forEach(o),qn.forEach(o),hn=c(t),q=a(t,"DIV",{class:!0});var V=s(q);v(lt.$$.fragment,V),Es=c(V),dt=a(V,"P",{});var Pn=s(dt);Ms=i(Pn,`The bare LLaMA Model outputting raw hidden-states without any specific head on top.
This model inherits from `),Nt=a(Pn,"A",{href:!0});var Oi=s(Nt);Fs=i(Oi,"PreTrainedModel"),Oi.forEach(o),Cs=i(Pn,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),Pn.forEach(o),xs=c(V),ct=a(V,"P",{});var An=s(ct);qs=i(An,"This model is also a PyTorch "),mt=a(An,"A",{href:!0,rel:!0});var Si=s(mt);Ps=i(Si,"torch.nn.Module"),Si.forEach(o),As=i(An,` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),An.forEach(o),Is=c(V),be=a(V,"P",{});var Vo=s(be);Os=i(Vo,"Transformer decoder consisting of "),Eo=a(Vo,"EM",{});var Di=s(Eo);Ss=i(Di,"config.num_hidden_layers"),Di.forEach(o),Ds=i(Vo," layers. Each layer is a "),Mo=a(Vo,"CODE",{});var Ni=s(Mo);Ns=i(Ni,"LlamaDecoderLayer"),Ni.forEach(o),Vo.forEach(o),js=c(V),H=a(V,"DIV",{class:!0});var Kt=s(H);v(pt.$$.fragment,Kt),Bs=c(Kt),te=a(Kt,"P",{});var Zt=s(te);Ws=i(Zt,"The "),jt=a(Zt,"A",{href:!0});var ji=s(jt);Hs=i(ji,"LlamaModel"),ji.forEach(o),Rs=i(Zt," forward method, overrides the "),Fo=a(Zt,"CODE",{});var Bi=s(Fo);Gs=i(Bi,"__call__"),Bi.forEach(o),Vs=i(Zt," special method."),Zt.forEach(o),Us=c(Kt),v(ye.$$.fragment,Kt),Kt.forEach(o),V.forEach(o),fn=c(t),oe=a(t,"H2",{class:!0});var In=s(oe);Le=a(In,"A",{id:!0,class:!0,href:!0});var Wi=s(Le);Co=a(Wi,"SPAN",{});var Hi=s(Co);v(ht.$$.fragment,Hi),Hi.forEach(o),Wi.forEach(o),Xs=c(In),xo=a(In,"SPAN",{});var Ri=s(xo);Js=i(Ri,"LlamaForCausalLM"),Ri.forEach(o),In.forEach(o),un=c(t),ne=a(t,"DIV",{class:!0});var On=s(ne);v(ft.$$.fragment,On),Ks=c(On),N=a(On,"DIV",{class:!0});var Fe=s(N);v(ut.$$.fragment,Fe),Zs=c(Fe),ae=a(Fe,"P",{});var Qt=s(ae);Qs=i(Qt,"The "),Bt=a(Qt,"A",{href:!0});var Gi=s(Bt);Ys=i(Gi,"LlamaForCausalLM"),Gi.forEach(o),er=i(Qt," forward method, overrides the "),qo=a(Qt,"CODE",{});var Vi=s(qo);tr=i(Vi,"__call__"),Vi.forEach(o),or=i(Qt," special method."),Qt.forEach(o),nr=c(Fe),v($e.$$.fragment,Fe),ar=c(Fe),v(Te.$$.fragment,Fe),Fe.forEach(o),On.forEach(o),_n=c(t),se=a(t,"H2",{class:!0});var Sn=s(se);we=a(Sn,"A",{id:!0,class:!0,href:!0});var Ui=s(we);Po=a(Ui,"SPAN",{});var Xi=s(Po);v(_t.$$.fragment,Xi),Xi.forEach(o),Ui.forEach(o),sr=c(Sn),Ao=a(Sn,"SPAN",{});var Ji=s(Ao);rr=i(Ji,"LlamaForSequenceClassification"),Ji.forEach(o),Sn.forEach(o),gn=c(t),E=a(t,"DIV",{class:!0});var I=s(E);v(gt.$$.fragment,I),ir=c(I),Io=a(I,"P",{});var Ki=s(Io);lr=i(Ki,"The LLaMa Model transformer with a sequence classification head on top (linear layer)."),Ki.forEach(o),dr=c(I),Wt=a(I,"P",{});var jr=s(Wt);Ht=a(jr,"A",{href:!0});var Zi=s(Ht);cr=i(Zi,"LlamaForSequenceClassification"),Zi.forEach(o),mr=i(jr,` uses the last token in order to do the classification, as other causal models
(e.g. GPT-2) do.`),jr.forEach(o),pr=c(I),S=a(I,"P",{});var U=s(S);hr=i(U,`Since it does classification on the last token, it requires to know the position of the last token. If a
`),Oo=a(U,"CODE",{});var Qi=s(Oo);fr=i(Qi,"pad_token_id"),Qi.forEach(o),ur=i(U,` is defined in the configuration, it finds the last token that is not a padding token in each row. If
no `),So=a(U,"CODE",{});var Yi=s(So);_r=i(Yi,"pad_token_id"),Yi.forEach(o),gr=i(U,` is defined, it simply takes the last value in each row of the batch. Since it cannot guess the
padding tokens when `),Do=a(U,"CODE",{});var el=s(Do);kr=i(el,"inputs_embeds"),el.forEach(o),vr=i(U," are passed instead of "),No=a(U,"CODE",{});var tl=s(No);br=i(tl,"input_ids"),tl.forEach(o),yr=i(U,`, it does the same (take the last value in
each row of the batch).`),U.forEach(o),Lr=c(I),kt=a(I,"P",{});var Dn=s(kt);$r=i(Dn,"This model inherits from "),Rt=a(Dn,"A",{href:!0});var ol=s(Rt);Tr=i(ol,"PreTrainedModel"),ol.forEach(o),wr=i(Dn,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),Dn.forEach(o),zr=c(I),vt=a(I,"P",{});var Nn=s(vt);Er=i(Nn,"This model is also a PyTorch "),bt=a(Nn,"A",{href:!0,rel:!0});var nl=s(bt);Mr=i(nl,"torch.nn.Module"),nl.forEach(o),Fr=i(Nn,` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),Nn.forEach(o),Cr=c(I),R=a(I,"DIV",{class:!0});var Yt=s(R);v(yt.$$.fragment,Yt),xr=c(Yt),re=a(Yt,"P",{});var eo=s(re);qr=i(eo,"The "),Gt=a(eo,"A",{href:!0});var al=s(Gt);Pr=i(al,"LlamaForSequenceClassification"),al.forEach(o),Ar=i(eo," forward method, overrides the "),jo=a(eo,"CODE",{});var sl=s(jo);Ir=i(sl,"__call__"),sl.forEach(o),Or=i(eo," special method."),eo.forEach(o),Sr=c(Yt),v(ze.$$.fragment,Yt),Yt.forEach(o),I.forEach(o),this.h()},h(){l(p,"name","hf:doc:metadata"),l(p,"content",JSON.stringify(vl)),l(_,"id","llama"),l(_,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(_,"href","#llama"),l(h,"class","relative group"),l(ie,"id","overview"),l(ie,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(ie,"href","#overview"),l(X,"class","relative group"),l(qe,"href","https://arxiv.org/abs/2302.13971"),l(qe,"rel","nofollow"),l(Pe,"href","https://docs.google.com/forms/d/e/1FAIpQLSfqNECQnMkycAp2jP4Z9TFX0cGR4uf7b_fBxjY_OjhJILlKGA/viewform?usp=send_form"),l(Pe,"rel","nofollow"),l(Ie,"href","https://github.com/huggingface/transformers/blob/main/src/transformers/models/llama/convert_llama_weights_to_hf.py"),l(Ie,"rel","nofollow"),l(Ne,"href","https://github.com/google/sentencepiece"),l(Ne,"rel","nofollow"),l(je,"href","https://huggingface.co/zphang"),l(je,"rel","nofollow"),l(Be,"href","https://huggingface.co/BlackSamorez"),l(Be,"rel","nofollow"),l(We,"href","https://github.com/EleutherAI/gpt-neox"),l(We,"rel","nofollow"),l(He,"href","https://github.com/facebookresearch/llama"),l(He,"rel","nofollow"),l(ce,"id","transformers.LlamaConfig"),l(ce,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(ce,"href","#transformers.LlamaConfig"),l(J,"class","relative group"),l(xt,"href","/docs/transformers/pr_21990/en/model_doc/llama#transformers.LlamaModel"),l(qt,"href","/docs/transformers/pr_21990/en/main_classes/configuration#transformers.PretrainedConfig"),l(Pt,"href","/docs/transformers/pr_21990/en/main_classes/configuration#transformers.PretrainedConfig"),l(O,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(pe,"id","transformers.LlamaTokenizer"),l(pe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(pe,"href","#transformers.LlamaTokenizer"),l(Z,"class","relative group"),l(At,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(he,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(D,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(ue,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(F,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(_e,"id","transformers.LlamaTokenizerFast"),l(_e,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(_e,"href","#transformers.LlamaTokenizerFast"),l(Q,"class","relative group"),l(It,"href","/docs/transformers/pr_21990/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast"),l(B,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(ke,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(St,"href","../glossary#token-type-ids"),l(W,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Dt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(z,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(ve,"id","transformers.LlamaModel"),l(ve,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(ve,"href","#transformers.LlamaModel"),l(ee,"class","relative group"),l(Nt,"href","/docs/transformers/pr_21990/en/main_classes/model#transformers.PreTrainedModel"),l(mt,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),l(mt,"rel","nofollow"),l(jt,"href","/docs/transformers/pr_21990/en/model_doc/llama#transformers.LlamaModel"),l(H,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(q,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Le,"id","transformers.LlamaForCausalLM"),l(Le,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(Le,"href","#transformers.LlamaForCausalLM"),l(oe,"class","relative group"),l(Bt,"href","/docs/transformers/pr_21990/en/model_doc/llama#transformers.LlamaForCausalLM"),l(N,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(ne,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(we,"id","transformers.LlamaForSequenceClassification"),l(we,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(we,"href","#transformers.LlamaForSequenceClassification"),l(se,"class","relative group"),l(Ht,"href","/docs/transformers/pr_21990/en/model_doc/llama#transformers.LlamaForSequenceClassification"),l(Rt,"href","/docs/transformers/pr_21990/en/main_classes/model#transformers.PreTrainedModel"),l(bt,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),l(bt,"rel","nofollow"),l(Gt,"href","/docs/transformers/pr_21990/en/model_doc/llama#transformers.LlamaForSequenceClassification"),l(R,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(E,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(t,m){e(document.head,p),u(t,T,m),u(t,h,m),e(h,_),e(_,w),b(f,w,null),e(h,g),e(h,P),e(P,Wn),u(t,Uo,m),u(t,X,m),e(X,ie),e(ie,oo),b(xe,oo,null),e(X,Hn),e(X,no),e(no,Rn),u(t,Xo,m),u(t,le,m),e(le,Gn),e(le,qe),e(qe,Vn),e(le,Un),u(t,Jo,m),u(t,Tt,m),e(Tt,Xn),u(t,Ko,m),u(t,wt,m),e(wt,ao),e(ao,Jn),u(t,Zo,m),u(t,zt,m),e(zt,Kn),u(t,Qo,m),u(t,de,m),e(de,Et),e(Et,Zn),e(Et,Pe),e(Pe,Qn),e(de,Yn),e(de,Ae),e(Ae,ea),e(Ae,Ie),e(Ie,ta),e(Ae,oa),u(t,Yo,m),b(Oe,t,m),u(t,en,m),u(t,Mt,m),e(Mt,so),e(so,na),u(t,tn,m),b(Se,t,m),u(t,on,m),u(t,Ft,m),e(Ft,aa),u(t,nn,m),u(t,Ct,m),e(Ct,De),e(De,sa),e(De,Ne),e(Ne,ra),e(De,ia),u(t,an,m),u(t,A,m),e(A,la),e(A,je),e(je,da),e(A,ca),e(A,Be),e(Be,ma),e(A,pa),e(A,We),e(We,ha),e(A,fa),e(A,He),e(He,ua),e(A,_a),u(t,sn,m),u(t,J,m),e(J,ce),e(ce,ro),b(Re,ro,null),e(J,ga),e(J,io),e(io,ka),u(t,rn,m),u(t,O,m),b(Ge,O,null),e(O,va),e(O,Ve),e(Ve,ba),e(Ve,xt),e(xt,ya),e(Ve,La),e(O,$a),e(O,K),e(K,Ta),e(K,qt),e(qt,wa),e(K,za),e(K,Pt),e(Pt,Ea),e(K,Ma),e(O,Fa),b(me,O,null),u(t,ln,m),u(t,Z,m),e(Z,pe),e(pe,lo),b(Ue,lo,null),e(Z,Ca),e(Z,co),e(co,xa),u(t,dn,m),u(t,F,m),b(Xe,F,null),e(F,qa),e(F,mo),e(mo,Pa),e(F,Aa),e(F,At),b(Je,At,null),e(F,Ia),e(F,he),b(Ke,he,null),e(he,Oa),e(he,Ze),e(Ze,Sa),e(Ze,po),e(po,Da),e(Ze,Na),e(F,ja),e(F,D),b(Qe,D,null),e(D,Ba),e(D,ho),e(ho,Wa),e(D,Ha),b(fe,D,null),e(D,Ra),e(D,fo),e(fo,Ga),e(F,Va),e(F,ue),b(Ye,ue,null),e(ue,Ua),e(ue,uo),e(uo,Xa),u(t,cn,m),u(t,Q,m),e(Q,_e),e(_e,_o),b(et,_o,null),e(Q,Ja),e(Q,go),e(go,Ka),u(t,mn,m),u(t,z,m),b(tt,z,null),e(z,Za),e(z,ko),e(ko,Qa),e(z,Ya),e(z,vo),e(vo,es),e(z,ts),b(ge,z,null),e(z,os),e(z,ot),e(ot,ns),e(ot,It),e(It,as),e(ot,ss),e(z,rs),e(z,B),b(nt,B,null),e(B,is),e(B,bo),e(bo,ls),e(B,ds),e(B,yo),e(yo,cs),e(z,ms),e(z,ke),b(at,ke,null),e(ke,ps),e(ke,Y),e(Y,hs),e(Y,Lo),e(Lo,fs),e(Y,us),e(Y,$o),e($o,_s),e(Y,gs),e(z,ks),e(z,W),b(st,W,null),e(W,vs),e(W,Ot),e(Ot,bs),e(Ot,St),e(St,ys),e(W,Ls),e(W,To),e(To,$s),e(z,Ts),e(z,Dt),b(rt,Dt,null),u(t,pn,m),u(t,ee,m),e(ee,ve),e(ve,wo),b(it,wo,null),e(ee,ws),e(ee,zo),e(zo,zs),u(t,hn,m),u(t,q,m),b(lt,q,null),e(q,Es),e(q,dt),e(dt,Ms),e(dt,Nt),e(Nt,Fs),e(dt,Cs),e(q,xs),e(q,ct),e(ct,qs),e(ct,mt),e(mt,Ps),e(ct,As),e(q,Is),e(q,be),e(be,Os),e(be,Eo),e(Eo,Ss),e(be,Ds),e(be,Mo),e(Mo,Ns),e(q,js),e(q,H),b(pt,H,null),e(H,Bs),e(H,te),e(te,Ws),e(te,jt),e(jt,Hs),e(te,Rs),e(te,Fo),e(Fo,Gs),e(te,Vs),e(H,Us),b(ye,H,null),u(t,fn,m),u(t,oe,m),e(oe,Le),e(Le,Co),b(ht,Co,null),e(oe,Xs),e(oe,xo),e(xo,Js),u(t,un,m),u(t,ne,m),b(ft,ne,null),e(ne,Ks),e(ne,N),b(ut,N,null),e(N,Zs),e(N,ae),e(ae,Qs),e(ae,Bt),e(Bt,Ys),e(ae,er),e(ae,qo),e(qo,tr),e(ae,or),e(N,nr),b($e,N,null),e(N,ar),b(Te,N,null),u(t,_n,m),u(t,se,m),e(se,we),e(we,Po),b(_t,Po,null),e(se,sr),e(se,Ao),e(Ao,rr),u(t,gn,m),u(t,E,m),b(gt,E,null),e(E,ir),e(E,Io),e(Io,lr),e(E,dr),e(E,Wt),e(Wt,Ht),e(Ht,cr),e(Wt,mr),e(E,pr),e(E,S),e(S,hr),e(S,Oo),e(Oo,fr),e(S,ur),e(S,So),e(So,_r),e(S,gr),e(S,Do),e(Do,kr),e(S,vr),e(S,No),e(No,br),e(S,yr),e(E,Lr),e(E,kt),e(kt,$r),e(kt,Rt),e(Rt,Tr),e(kt,wr),e(E,zr),e(E,vt),e(vt,Er),e(vt,bt),e(bt,Mr),e(vt,Fr),e(E,Cr),e(E,R),b(yt,R,null),e(R,xr),e(R,re),e(re,qr),e(re,Gt),e(Gt,Pr),e(re,Ar),e(re,jo),e(jo,Ir),e(re,Or),e(R,Sr),b(ze,R,null),kn=!0},p(t,[m]){const Lt={};m&2&&(Lt.$$scope={dirty:m,ctx:t}),me.$set(Lt);const Bo={};m&2&&(Bo.$$scope={dirty:m,ctx:t}),fe.$set(Bo);const Wo={};m&2&&(Wo.$$scope={dirty:m,ctx:t}),ge.$set(Wo);const Ho={};m&2&&(Ho.$$scope={dirty:m,ctx:t}),ye.$set(Ho);const $t={};m&2&&($t.$$scope={dirty:m,ctx:t}),$e.$set($t);const Ro={};m&2&&(Ro.$$scope={dirty:m,ctx:t}),Te.$set(Ro);const Go={};m&2&&(Go.$$scope={dirty:m,ctx:t}),ze.$set(Go)},i(t){kn||(y(f.$$.fragment,t),y(xe.$$.fragment,t),y(Oe.$$.fragment,t),y(Se.$$.fragment,t),y(Re.$$.fragment,t),y(Ge.$$.fragment,t),y(me.$$.fragment,t),y(Ue.$$.fragment,t),y(Xe.$$.fragment,t),y(Je.$$.fragment,t),y(Ke.$$.fragment,t),y(Qe.$$.fragment,t),y(fe.$$.fragment,t),y(Ye.$$.fragment,t),y(et.$$.fragment,t),y(tt.$$.fragment,t),y(ge.$$.fragment,t),y(nt.$$.fragment,t),y(at.$$.fragment,t),y(st.$$.fragment,t),y(rt.$$.fragment,t),y(it.$$.fragment,t),y(lt.$$.fragment,t),y(pt.$$.fragment,t),y(ye.$$.fragment,t),y(ht.$$.fragment,t),y(ft.$$.fragment,t),y(ut.$$.fragment,t),y($e.$$.fragment,t),y(Te.$$.fragment,t),y(_t.$$.fragment,t),y(gt.$$.fragment,t),y(yt.$$.fragment,t),y(ze.$$.fragment,t),kn=!0)},o(t){L(f.$$.fragment,t),L(xe.$$.fragment,t),L(Oe.$$.fragment,t),L(Se.$$.fragment,t),L(Re.$$.fragment,t),L(Ge.$$.fragment,t),L(me.$$.fragment,t),L(Ue.$$.fragment,t),L(Xe.$$.fragment,t),L(Je.$$.fragment,t),L(Ke.$$.fragment,t),L(Qe.$$.fragment,t),L(fe.$$.fragment,t),L(Ye.$$.fragment,t),L(et.$$.fragment,t),L(tt.$$.fragment,t),L(ge.$$.fragment,t),L(nt.$$.fragment,t),L(at.$$.fragment,t),L(st.$$.fragment,t),L(rt.$$.fragment,t),L(it.$$.fragment,t),L(lt.$$.fragment,t),L(pt.$$.fragment,t),L(ye.$$.fragment,t),L(ht.$$.fragment,t),L(ft.$$.fragment,t),L(ut.$$.fragment,t),L($e.$$.fragment,t),L(Te.$$.fragment,t),L(_t.$$.fragment,t),L(gt.$$.fragment,t),L(yt.$$.fragment,t),L(ze.$$.fragment,t),kn=!1},d(t){o(p),t&&o(T),t&&o(h),$(f),t&&o(Uo),t&&o(X),$(xe),t&&o(Xo),t&&o(le),t&&o(Jo),t&&o(Tt),t&&o(Ko),t&&o(wt),t&&o(Zo),t&&o(zt),t&&o(Qo),t&&o(de),t&&o(Yo),$(Oe,t),t&&o(en),t&&o(Mt),t&&o(tn),$(Se,t),t&&o(on),t&&o(Ft),t&&o(nn),t&&o(Ct),t&&o(an),t&&o(A),t&&o(sn),t&&o(J),$(Re),t&&o(rn),t&&o(O),$(Ge),$(me),t&&o(ln),t&&o(Z),$(Ue),t&&o(dn),t&&o(F),$(Xe),$(Je),$(Ke),$(Qe),$(fe),$(Ye),t&&o(cn),t&&o(Q),$(et),t&&o(mn),t&&o(z),$(tt),$(ge),$(nt),$(at),$(st),$(rt),t&&o(pn),t&&o(ee),$(it),t&&o(hn),t&&o(q),$(lt),$(pt),$(ye),t&&o(fn),t&&o(oe),$(ht),t&&o(un),t&&o(ne),$(ft),$(ut),$($e),$(Te),t&&o(_n),t&&o(se),$(_t),t&&o(gn),t&&o(E),$(gt),$(yt),$(ze)}}}const vl={local:"llama",sections:[{local:"overview",title:"Overview"},{local:"transformers.LlamaConfig",title:"LlamaConfig"},{local:"transformers.LlamaTokenizer",title:"LlamaTokenizer"},{local:"transformers.LlamaTokenizerFast",title:"LlamaTokenizerFast"},{local:"transformers.LlamaModel",title:"LlamaModel"},{local:"transformers.LlamaForCausalLM",title:"LlamaForCausalLM"},{local:"transformers.LlamaForSequenceClassification",title:"LlamaForSequenceClassification"}],title:"LLaMA"};function bl(x){return cl(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class El extends rl{constructor(p){super();il(this,p,bl,kl,ll,{})}}export{El as default,vl as metadata};
