import{S as Hl,i as Wl,s as Bl,e as s,k as c,w as v,t as r,M as Gl,c as n,d as o,m as h,a as i,x as T,h as a,b as l,N as Ul,G as e,g as m,y as b,q as C,o as w,B as k,v as Xl,L as Sl}from"../../chunks/vendor-hf-doc-builder.js";import{T as Fl}from"../../chunks/Tip-hf-doc-builder.js";import{D as ne}from"../../chunks/Docstring-hf-doc-builder.js";import{C as di}from"../../chunks/CodeBlock-hf-doc-builder.js";import{I as $t}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{E as Nl}from"../../chunks/ExampleCodeBlock-hf-doc-builder.js";import{P as Vl}from"../../chunks/PipelineTag-hf-doc-builder.js";function Zl(B){let f,$,u,g,y;return g=new di({props:{code:`from transformers import TrOCRConfig, TrOCRForCausalLM

# Initializing a TrOCR-base style configuration
configuration = TrOCRConfig()

# Initializing a model (with random weights) from the TrOCR-base style configuration
model = TrOCRForCausalLM(configuration)

# Accessing the model configuration
configuration = model.config`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> TrOCRConfig, TrOCRForCausalLM

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a TrOCR-base style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = TrOCRConfig()

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a model (with random weights) from the TrOCR-base style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = TrOCRForCausalLM(configuration)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Accessing the model configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = model.config`}}),{c(){f=s("p"),$=r("Example:"),u=c(),v(g.$$.fragment)},l(p){f=n(p,"P",{});var _=i(f);$=a(_,"Example:"),_.forEach(o),u=h(p),T(g.$$.fragment,p)},m(p,_){m(p,f,_),e(f,$),m(p,u,_),b(g,p,_),y=!0},p:Sl,i(p){y||(C(g.$$.fragment,p),y=!0)},o(p){w(g.$$.fragment,p),y=!1},d(p){p&&o(f),p&&o(u),k(g,p)}}}function Jl(B){let f,$,u,g,y,p,_,q,z,P,I;return{c(){f=s("p"),$=r(`This class method is simply calling the feature extractor
`),u=s("a"),g=r("from_pretrained()"),y=r(`, image processor
`),p=s("a"),_=r("ImageProcessingMixin"),q=r(` and the tokenizer
`),z=s("code"),P=r("~tokenization_utils_base.PreTrainedTokenizer.from_pretrained"),I=r(` methods. Please refer to the docstrings of the
methods above for more information.`),this.h()},l(M){f=n(M,"P",{});var A=i(f);$=a(A,`This class method is simply calling the feature extractor
`),u=n(A,"A",{href:!0});var G=i(u);g=a(G,"from_pretrained()"),G.forEach(o),y=a(A,`, image processor
`),p=n(A,"A",{href:!0});var Et=i(p);_=a(Et,"ImageProcessingMixin"),Et.forEach(o),q=a(A,` and the tokenizer
`),z=n(A,"CODE",{});var ie=i(z);P=a(ie,"~tokenization_utils_base.PreTrainedTokenizer.from_pretrained"),ie.forEach(o),I=a(A,` methods. Please refer to the docstrings of the
methods above for more information.`),A.forEach(o),this.h()},h(){l(u,"href","/docs/transformers/pr_21990/en/main_classes/feature_extractor#transformers.FeatureExtractionMixin.from_pretrained"),l(p,"href","/docs/transformers/pr_21990/en/main_classes/image_processor#transformers.ImageProcessingMixin")},m(M,A){m(M,f,A),e(f,$),e(f,u),e(u,g),e(f,y),e(f,p),e(p,_),e(f,q),e(f,z),e(z,P),e(f,I)},d(M){M&&o(f)}}}function Yl(B){let f,$,u,g,y,p,_,q;return{c(){f=s("p"),$=r("This class method is simply calling "),u=s("a"),g=r("save_pretrained()"),y=r(` and
`),p=s("a"),_=r("save_pretrained()"),q=r(`. Please refer to the docstrings of the
methods above for more information.`),this.h()},l(z){f=n(z,"P",{});var P=i(f);$=a(P,"This class method is simply calling "),u=n(P,"A",{href:!0});var I=i(u);g=a(I,"save_pretrained()"),I.forEach(o),y=a(P,` and
`),p=n(P,"A",{href:!0});var M=i(p);_=a(M,"save_pretrained()"),M.forEach(o),q=a(P,`. Please refer to the docstrings of the
methods above for more information.`),P.forEach(o),this.h()},h(){l(u,"href","/docs/transformers/pr_21990/en/main_classes/feature_extractor#transformers.FeatureExtractionMixin.save_pretrained"),l(p,"href","/docs/transformers/pr_21990/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.save_pretrained")},m(z,P){m(z,f,P),e(f,$),e(f,u),e(u,g),e(f,y),e(f,p),e(p,_),e(f,q)},d(z){z&&o(f)}}}function Kl(B){let f,$,u,g,y;return g=new di({props:{code:`from transformers import (
    TrOCRConfig,
    TrOCRProcessor,
    TrOCRForCausalLM,
    ViTConfig,
    ViTModel,
    VisionEncoderDecoderModel,
)
import requests
from PIL import Image

# TrOCR is a decoder model and should be used within a VisionEncoderDecoderModel
# init vision2text model with random weights
encoder = ViTModel(ViTConfig())
decoder = TrOCRForCausalLM(TrOCRConfig())
model = VisionEncoderDecoderModel(encoder=encoder, decoder=decoder)

# If you want to start from the pretrained model, load the checkpoint with \`VisionEncoderDecoderModel\`
processor = TrOCRProcessor.from_pretrained("microsoft/trocr-base-handwritten")
model = VisionEncoderDecoderModel.from_pretrained("microsoft/trocr-base-handwritten")

# load image from the IAM dataset
url = "https://fki.tic.heia-fr.ch/static/img/a01-122-02.jpg"
image = Image.open(requests.get(url, stream=True).raw).convert("RGB")
pixel_values = processor(image, return_tensors="pt").pixel_values
text = "industry, ' Mr. Brown commented icily. ' Let us have a"

# training
model.config.decoder_start_token_id = processor.tokenizer.cls_token_id
model.config.pad_token_id = processor.tokenizer.pad_token_id
model.config.vocab_size = model.config.decoder.vocab_size

labels = processor.tokenizer(text, return_tensors="pt").input_ids
outputs = model(pixel_values, labels=labels)
loss = outputs.loss
round(loss.item(), 2)

# inference
generated_ids = model.generate(pixel_values)
generated_text = processor.batch_decode(generated_ids, skip_special_tokens=True)[0]
generated_text`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> (
<span class="hljs-meta">... </span>    TrOCRConfig,
<span class="hljs-meta">... </span>    TrOCRProcessor,
<span class="hljs-meta">... </span>    TrOCRForCausalLM,
<span class="hljs-meta">... </span>    ViTConfig,
<span class="hljs-meta">... </span>    ViTModel,
<span class="hljs-meta">... </span>    VisionEncoderDecoderModel,
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> requests
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># TrOCR is a decoder model and should be used within a VisionEncoderDecoderModel</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># init vision2text model with random weights</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>encoder = ViTModel(ViTConfig())
<span class="hljs-meta">&gt;&gt;&gt; </span>decoder = TrOCRForCausalLM(TrOCRConfig())
<span class="hljs-meta">&gt;&gt;&gt; </span>model = VisionEncoderDecoderModel(encoder=encoder, decoder=decoder)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># If you want to start from the pretrained model, load the checkpoint with \`VisionEncoderDecoderModel\`</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>processor = TrOCRProcessor.from_pretrained(<span class="hljs-string">&quot;microsoft/trocr-base-handwritten&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = VisionEncoderDecoderModel.from_pretrained(<span class="hljs-string">&quot;microsoft/trocr-base-handwritten&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># load image from the IAM dataset</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>url = <span class="hljs-string">&quot;https://fki.tic.heia-fr.ch/static/img/a01-122-02.jpg&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image = Image.<span class="hljs-built_in">open</span>(requests.get(url, stream=<span class="hljs-literal">True</span>).raw).convert(<span class="hljs-string">&quot;RGB&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>pixel_values = processor(image, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>).pixel_values
<span class="hljs-meta">&gt;&gt;&gt; </span>text = <span class="hljs-string">&quot;industry, &#x27; Mr. Brown commented icily. &#x27; Let us have a&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># training</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model.config.decoder_start_token_id = processor.tokenizer.cls_token_id
<span class="hljs-meta">&gt;&gt;&gt; </span>model.config.pad_token_id = processor.tokenizer.pad_token_id
<span class="hljs-meta">&gt;&gt;&gt; </span>model.config.vocab_size = model.config.decoder.vocab_size

<span class="hljs-meta">&gt;&gt;&gt; </span>labels = processor.tokenizer(text, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>).input_ids
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(pixel_values, labels=labels)
<span class="hljs-meta">&gt;&gt;&gt; </span>loss = outputs.loss
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">round</span>(loss.item(), <span class="hljs-number">2</span>)
<span class="hljs-number">5.30</span>

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># inference</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>generated_ids = model.generate(pixel_values)
<span class="hljs-meta">&gt;&gt;&gt; </span>generated_text = processor.batch_decode(generated_ids, skip_special_tokens=<span class="hljs-literal">True</span>)[<span class="hljs-number">0</span>]
<span class="hljs-meta">&gt;&gt;&gt; </span>generated_text
<span class="hljs-string">&#x27;industry, &quot; Mr. Brown commented icily. &quot; Let us have a&#x27;</span>`}}),{c(){f=s("p"),$=r("Example:"),u=c(),v(g.$$.fragment)},l(p){f=n(p,"P",{});var _=i(f);$=a(_,"Example:"),_.forEach(o),u=h(p),T(g.$$.fragment,p)},m(p,_){m(p,f,_),e(f,$),m(p,u,_),b(g,p,_),y=!0},p:Sl,i(p){y||(C(g.$$.fragment,p),y=!0)},o(p){w(g.$$.fragment,p),y=!1},d(p){p&&o(f),p&&o(u),k(g,p)}}}function Ql(B){let f,$,u,g,y,p,_,q,z,P,I,M,A,G,Et,ie,Br,Ho,U,Gr,Pe,Ur,Xr,Me,Zr,Jr,Wo,xt,Yr,Bo,Pt,no,Kr,Go,le,ci,Uo,de,Qr,Mt,ea,ta,Xo,ce,oa,io,ra,aa,Zo,X,sa,Ie,na,ia,Ae,la,da,Jo,It,ca,Yo,Z,je,ha,Le,ma,pa,fa,S,ua,ze,ga,_a,De,va,Ta,qe,ba,Ca,wa,Fe,ka,At,Oa,ya,Ko,Q,he,lo,Ne,Ra,co,$a,Qo,jt,Ea,er,Ve,tr,j,Se,xa,He,Pa,Ma,Ia,We,Aa,Be,ja,La,za,Ge,Da,Ue,qa,Fa,Na,Xe,Va,Ze,Sa,Ha,Wa,Je,Ba,Ye,Ga,Ua,Xa,Ke,Za,Qe,Ja,Ya,or,et,rr,Lt,zt,tt,Ka,Qa,ar,Dt,es,sr,qt,ot,ts,rt,os,rs,nr,ee,me,ho,at,as,mo,ss,ir,J,ns,po,is,ls,Ft,ds,cs,lr,O,hs,fo,ms,ps,uo,fs,us,go,gs,_s,_o,vs,Ts,Nt,bs,Cs,vo,ws,ks,To,Os,ys,bo,Rs,$s,Co,Es,xs,dr,Vt,wo,Ps,cr,st,hr,pe,Ms,nt,Is,As,mr,te,fe,ko,it,js,Oo,Ls,pr,F,lt,zs,oe,Ds,St,qs,Fs,dt,Ns,Vs,Ss,re,Hs,Ht,Ws,Bs,Wt,Gs,Us,Xs,ue,fr,ae,ge,yo,ct,Zs,Ro,Js,ur,R,ht,Ys,$o,Ks,Qs,x,Bt,en,tn,Eo,on,rn,xo,an,sn,Po,nn,ln,Mo,dn,cn,mt,Io,hn,mn,pn,Gt,fn,un,gn,_e,pt,_n,H,vn,Ao,Tn,bn,jo,Cn,wn,Lo,kn,On,yn,Y,ft,Rn,zo,$n,En,ve,xn,K,ut,Pn,gt,Mn,Ut,In,An,jn,Te,Ln,be,_t,zn,vt,Dn,Xt,qn,Fn,Nn,Ce,Tt,Vn,bt,Sn,Zt,Hn,Wn,gr,se,we,Do,Ct,Bn,qo,Gn,_r,N,wt,Un,W,Xn,Jt,Zn,Jn,Fo,Yn,Kn,Yt,Qn,ei,ti,kt,oi,Ot,ri,ai,si,ke,yt,ni,Oe,vr;return p=new $t({}),G=new $t({}),Ne=new $t({}),Ve=new Vl({props:{pipeline:"text-classification"}}),et=new Vl({props:{pipeline:"text-generation"}}),at=new $t({}),st=new di({props:{code:`from transformers import TrOCRProcessor, VisionEncoderDecoderModel
import requests
from PIL import Image

processor = TrOCRProcessor.from_pretrained("microsoft/trocr-base-handwritten")
model = VisionEncoderDecoderModel.from_pretrained("microsoft/trocr-base-handwritten")

# load image from the IAM dataset
url = "https://fki.tic.heia-fr.ch/static/img/a01-122-02.jpg"
image = Image.open(requests.get(url, stream=True).raw).convert("RGB")

pixel_values = processor(image, return_tensors="pt").pixel_values
generated_ids = model.generate(pixel_values)

generated_text = processor.batch_decode(generated_ids, skip_special_tokens=True)[0]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> TrOCRProcessor, VisionEncoderDecoderModel
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> requests
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image

<span class="hljs-meta">&gt;&gt;&gt; </span>processor = TrOCRProcessor.from_pretrained(<span class="hljs-string">&quot;microsoft/trocr-base-handwritten&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = VisionEncoderDecoderModel.from_pretrained(<span class="hljs-string">&quot;microsoft/trocr-base-handwritten&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># load image from the IAM dataset</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>url = <span class="hljs-string">&quot;https://fki.tic.heia-fr.ch/static/img/a01-122-02.jpg&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image = Image.<span class="hljs-built_in">open</span>(requests.get(url, stream=<span class="hljs-literal">True</span>).raw).convert(<span class="hljs-string">&quot;RGB&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>pixel_values = processor(image, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>).pixel_values
<span class="hljs-meta">&gt;&gt;&gt; </span>generated_ids = model.generate(pixel_values)

<span class="hljs-meta">&gt;&gt;&gt; </span>generated_text = processor.batch_decode(generated_ids, skip_special_tokens=<span class="hljs-literal">True</span>)[<span class="hljs-number">0</span>]`}}),it=new $t({}),lt=new ne({props:{name:"class transformers.TrOCRConfig",anchor:"transformers.TrOCRConfig",parameters:[{name:"vocab_size",val:" = 50265"},{name:"d_model",val:" = 1024"},{name:"decoder_layers",val:" = 12"},{name:"decoder_attention_heads",val:" = 16"},{name:"decoder_ffn_dim",val:" = 4096"},{name:"activation_function",val:" = 'gelu'"},{name:"max_position_embeddings",val:" = 512"},{name:"dropout",val:" = 0.1"},{name:"attention_dropout",val:" = 0.0"},{name:"activation_dropout",val:" = 0.0"},{name:"decoder_start_token_id",val:" = 2"},{name:"init_std",val:" = 0.02"},{name:"decoder_layerdrop",val:" = 0.0"},{name:"use_cache",val:" = True"},{name:"scale_embedding",val:" = False"},{name:"use_learned_position_embeddings",val:" = True"},{name:"layernorm_embedding",val:" = True"},{name:"pad_token_id",val:" = 1"},{name:"bos_token_id",val:" = 0"},{name:"eos_token_id",val:" = 2"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.TrOCRConfig.vocab_size",description:`<strong>vocab_size</strong> (<code>int</code>, <em>optional</em>, defaults to 50265) &#x2014;
Vocabulary size of the TrOCR model. Defines the number of different tokens that can be represented by the
<code>inputs_ids</code> passed when calling <a href="/docs/transformers/pr_21990/en/model_doc/trocr#transformers.TrOCRForCausalLM">TrOCRForCausalLM</a>.`,name:"vocab_size"},{anchor:"transformers.TrOCRConfig.d_model",description:`<strong>d_model</strong> (<code>int</code>, <em>optional</em>, defaults to 1024) &#x2014;
Dimensionality of the layers and the pooler layer.`,name:"d_model"},{anchor:"transformers.TrOCRConfig.decoder_layers",description:`<strong>decoder_layers</strong> (<code>int</code>, <em>optional</em>, defaults to 12) &#x2014;
Number of decoder layers.`,name:"decoder_layers"},{anchor:"transformers.TrOCRConfig.decoder_attention_heads",description:`<strong>decoder_attention_heads</strong> (<code>int</code>, <em>optional</em>, defaults to 16) &#x2014;
Number of attention heads for each attention layer in the Transformer decoder.`,name:"decoder_attention_heads"},{anchor:"transformers.TrOCRConfig.decoder_ffn_dim",description:`<strong>decoder_ffn_dim</strong> (<code>int</code>, <em>optional</em>, defaults to 4096) &#x2014;
Dimensionality of the &#x201C;intermediate&#x201D; (often named feed-forward) layer in decoder.`,name:"decoder_ffn_dim"},{anchor:"transformers.TrOCRConfig.activation_function",description:`<strong>activation_function</strong> (<code>str</code> or <code>function</code>, <em>optional</em>, defaults to <code>&quot;gelu&quot;</code>) &#x2014;
The non-linear activation function (function or string) in the pooler. If string, <code>&quot;gelu&quot;</code>, <code>&quot;relu&quot;</code>,
<code>&quot;silu&quot;</code> and <code>&quot;gelu_new&quot;</code> are supported.`,name:"activation_function"},{anchor:"transformers.TrOCRConfig.max_position_embeddings",description:`<strong>max_position_embeddings</strong> (<code>int</code>, <em>optional</em>, defaults to 512) &#x2014;
The maximum sequence length that this model might ever be used with. Typically set this to something large
just in case (e.g., 512 or 1024 or 2048).`,name:"max_position_embeddings"},{anchor:"transformers.TrOCRConfig.dropout",description:`<strong>dropout</strong> (<code>float</code>, <em>optional</em>, defaults to 0.1) &#x2014;
The dropout probability for all fully connected layers in the embeddings, and pooler.`,name:"dropout"},{anchor:"transformers.TrOCRConfig.attention_dropout",description:`<strong>attention_dropout</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
The dropout ratio for the attention probabilities.`,name:"attention_dropout"},{anchor:"transformers.TrOCRConfig.activation_dropout",description:`<strong>activation_dropout</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
The dropout ratio for activations inside the fully connected layer.`,name:"activation_dropout"},{anchor:"transformers.TrOCRConfig.init_std",description:`<strong>init_std</strong> (<code>float</code>, <em>optional</em>, defaults to 0.02) &#x2014;
The standard deviation of the truncated_normal_initializer for initializing all weight matrices.`,name:"init_std"},{anchor:"transformers.TrOCRConfig.decoder_layerdrop",description:`<strong>decoder_layerdrop</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
The LayerDrop probability for the decoder. See the [LayerDrop paper](see <a href="https://arxiv.org/abs/1909.11556" rel="nofollow">https://arxiv.org/abs/1909.11556</a>)
for more details.`,name:"decoder_layerdrop"},{anchor:"transformers.TrOCRConfig.use_cache",description:`<strong>use_cache</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not the model should return the last key/values attentions (not used by all models).`,name:"use_cache"},{anchor:"transformers.TrOCRConfig.scale_embedding",description:`<strong>scale_embedding</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to scale the word embeddings by sqrt(d_model).`,name:"scale_embedding"},{anchor:"transformers.TrOCRConfig.use_learned_position_embeddings",description:`<strong>use_learned_position_embeddings</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to use learned position embeddings. If not, sinusoidal position embeddings will be used.`,name:"use_learned_position_embeddings"},{anchor:"transformers.TrOCRConfig.layernorm_embedding",description:`<strong>layernorm_embedding</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to use a layernorm after the word + position embeddings.`,name:"layernorm_embedding"}],source:"https://github.com/huggingface/transformers/blob/vr_21990/src/transformers/models/trocr/configuration_trocr.py#L31"}}),ue=new Nl({props:{anchor:"transformers.TrOCRConfig.example",$$slots:{default:[Zl]},$$scope:{ctx:B}}}),ct=new $t({}),ht=new ne({props:{name:"class transformers.TrOCRProcessor",anchor:"transformers.TrOCRProcessor",parameters:[{name:"image_processor",val:" = None"},{name:"tokenizer",val:" = None"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.TrOCRProcessor.image_processor",description:`<strong>image_processor</strong> ([<code>ViTImageProcessor</code>/<code>DeiTImageProcessor</code>]) &#x2014;
An instance of [<code>ViTImageProcessor</code>/<code>DeiTImageProcessor</code>]. The image processor is a required input.`,name:"image_processor"},{anchor:"transformers.TrOCRProcessor.tokenizer",description:`<strong>tokenizer</strong> ([<code>RobertaTokenizer</code>/<code>XLMRobertaTokenizer</code>]) &#x2014;
An instance of [<code>RobertaTokenizer</code>/<code>XLMRobertaTokenizer</code>]. The tokenizer is a required input.`,name:"tokenizer"}],source:"https://github.com/huggingface/transformers/blob/vr_21990/src/transformers/models/trocr/processing_trocr.py#L24"}}),pt=new ne({props:{name:"__call__",anchor:"transformers.TrOCRProcessor.__call__",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/transformers/blob/vr_21990/src/transformers/models/trocr/processing_trocr.py#L61"}}),ft=new ne({props:{name:"from_pretrained",anchor:"transformers.TrOCRProcessor.from_pretrained",parameters:[{name:"pretrained_model_name_or_path",val:""},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.TrOCRProcessor.from_pretrained.pretrained_model_name_or_path",description:`<strong>pretrained_model_name_or_path</strong> (<code>str</code> or <code>os.PathLike</code>) &#x2014;
This can be either:</p>
<ul>
<li>a string, the <em>model id</em> of a pretrained feature_extractor hosted inside a model repo on
huggingface.co. Valid model ids can be located at the root-level, like <code>bert-base-uncased</code>, or
namespaced under a user or organization name, like <code>dbmdz/bert-base-german-cased</code>.</li>
<li>a path to a <em>directory</em> containing a feature extractor file saved using the
<a href="/docs/transformers/pr_21990/en/main_classes/feature_extractor#transformers.FeatureExtractionMixin.save_pretrained">save_pretrained()</a> method, e.g., <code>./my_model_directory/</code>.</li>
<li>a path or url to a saved feature extractor JSON <em>file</em>, e.g.,
<code>./my_model_directory/preprocessor_config.json</code>.
**kwargs &#x2014;
Additional keyword arguments passed along to both
<a href="/docs/transformers/pr_21990/en/main_classes/feature_extractor#transformers.FeatureExtractionMixin.from_pretrained">from_pretrained()</a> and
<code>~tokenization_utils_base.PreTrainedTokenizer.from_pretrained</code>.</li>
</ul>`,name:"pretrained_model_name_or_path"}],source:"https://github.com/huggingface/transformers/blob/vr_21990/src/transformers/processing_utils.py#L153"}}),ve=new Fl({props:{$$slots:{default:[Jl]},$$scope:{ctx:B}}}),ut=new ne({props:{name:"save_pretrained",anchor:"transformers.TrOCRProcessor.save_pretrained",parameters:[{name:"save_directory",val:""},{name:"push_to_hub",val:": bool = False"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.TrOCRProcessor.save_pretrained.save_directory",description:`<strong>save_directory</strong> (<code>str</code> or <code>os.PathLike</code>) &#x2014;
Directory where the feature extractor JSON file and the tokenizer files will be saved (directory will
be created if it does not exist).`,name:"save_directory"},{anchor:"transformers.TrOCRProcessor.save_pretrained.push_to_hub",description:`<strong>push_to_hub</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to push your model to the Hugging Face model hub after saving it. You can specify the
repository you want to push to with <code>repo_id</code> (will default to the name of <code>save_directory</code> in your
namespace).
kwargs &#x2014;
Additional key word arguments passed along to the <a href="/docs/transformers/pr_21990/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.push_to_hub">push_to_hub()</a> method.`,name:"push_to_hub"}],source:"https://github.com/huggingface/transformers/blob/vr_21990/src/transformers/processing_utils.py#L91"}}),Te=new Fl({props:{$$slots:{default:[Yl]},$$scope:{ctx:B}}}),_t=new ne({props:{name:"batch_decode",anchor:"transformers.TrOCRProcessor.batch_decode",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/transformers/blob/vr_21990/src/transformers/models/trocr/processing_trocr.py#L94"}}),Tt=new ne({props:{name:"decode",anchor:"transformers.TrOCRProcessor.decode",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/transformers/blob/vr_21990/src/transformers/models/trocr/processing_trocr.py#L101"}}),Ct=new $t({}),wt=new ne({props:{name:"class transformers.TrOCRForCausalLM",anchor:"transformers.TrOCRForCausalLM",parameters:[{name:"config",val:""}],parametersDescription:[{anchor:"transformers.TrOCRForCausalLM.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_21990/en/model_doc/trocr#transformers.TrOCRConfig">TrOCRConfig</a>) &#x2014;
Model configuration class with all the parameters of the model. Initializing with a config file does not
load the weights associated with the model, only the configuration. Check out the
<a href="/docs/transformers/pr_21990/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_21990/src/transformers/models/trocr/modeling_trocr.py#L790"}}),yt=new ne({props:{name:"forward",anchor:"transformers.TrOCRForCausalLM.forward",parameters:[{name:"input_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"attention_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"encoder_hidden_states",val:": typing.Optional[torch.FloatTensor] = None"},{name:"encoder_attention_mask",val:": typing.Optional[torch.LongTensor] = None"},{name:"head_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"cross_attn_head_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"past_key_values",val:": typing.Optional[typing.Tuple[typing.Tuple[torch.FloatTensor]]] = None"},{name:"inputs_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"labels",val:": typing.Optional[torch.LongTensor] = None"},{name:"use_cache",val:": typing.Optional[bool] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.TrOCRForCausalLM.forward.input_ids",description:`<strong>input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary. Padding will be ignored by default should you
provide it.</p>
<p>Indices can be obtained using <a href="/docs/transformers/pr_21990/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/pr_21990/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/pr_21990/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.TrOCRForCausalLM.forward.attention_mask",description:`<strong>attention_mask</strong> (<code>torch.Tensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.TrOCRForCausalLM.forward.encoder_hidden_states",description:`<strong>encoder_hidden_states</strong>  (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Sequence of hidden-states at the output of the last layer of the encoder. Used in the cross-attention
if the model is configured as a decoder.`,name:"encoder_hidden_states"},{anchor:"transformers.TrOCRForCausalLM.forward.encoder_attention_mask",description:`<strong>encoder_attention_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on the padding token indices of the encoder input. This mask is used
in the cross-attention if the model is configured as a decoder. Mask values selected in <code>[0, 1]</code>:`,name:"encoder_attention_mask"},{anchor:"transformers.TrOCRForCausalLM.forward.head_mask",description:`<strong>head_mask</strong> (<code>torch.Tensor</code> of shape <code>(decoder_layers, decoder_attention_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the attention modules. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.TrOCRForCausalLM.forward.cross_attn_head_mask",description:`<strong>cross_attn_head_mask</strong> (<code>torch.Tensor</code> of shape <code>(decoder_layers, decoder_attention_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the cross-attention modules. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"cross_attn_head_mask"},{anchor:"transformers.TrOCRForCausalLM.forward.past_key_values",description:`<strong>past_key_values</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>use_cache=True</code> is passed or when <code>config.use_cache=True</code>) &#x2014;
Tuple of <code>tuple(torch.FloatTensor)</code> of length <code>config.n_layers</code>, with each tuple having 2 tensors of
shape <code>(batch_size, num_heads, sequence_length, embed_size_per_head)</code>) and 2 additional tensors of
shape <code>(batch_size, num_heads, encoder_sequence_length, embed_size_per_head)</code>. The two additional
tensors are only required when the model is used as a decoder in a Sequence to Sequence model.</p>
<p>Contains pre-computed hidden-states (key and values in the self-attention blocks and in the
cross-attention blocks) that can be used (see <code>past_key_values</code> input) to speed up sequential decoding.</p>
<p>If <code>past_key_values</code> are used, the user can optionally input only the last <code>decoder_input_ids</code> (those
that don&#x2019;t have their past key value states given to this model) of shape <code>(batch_size, 1)</code> instead of
all <code>decoder_input_ids</code> of shape <code>(batch_size, sequence_length)</code>.`,name:"past_key_values"},{anchor:"transformers.TrOCRForCausalLM.forward.labels",description:`<strong>labels</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Labels for computing the masked language modeling loss. Indices should either be in <code>[0, ..., config.vocab_size]</code> or -100 (see <code>input_ids</code> docstring). Tokens with indices set to <code>-100</code> are ignored
(masked), the loss is only computed for the tokens with labels in <code>[0, ..., config.vocab_size]</code>.`,name:"labels"},{anchor:"transformers.TrOCRForCausalLM.forward.use_cache",description:`<strong>use_cache</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
If set to <code>True</code>, <code>past_key_values</code> key value states are returned and can be used to speed up decoding
(see <code>past_key_values</code>).</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>`,name:"use_cache"},{anchor:"transformers.TrOCRForCausalLM.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under
returned tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.TrOCRForCausalLM.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors
for more detail.`,name:"output_hidden_states"},{anchor:"transformers.TrOCRForCausalLM.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_21990/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/vr_21990/src/transformers/models/trocr/modeling_trocr.py#L823",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_21990/en/main_classes/output#transformers.modeling_outputs.CausalLMOutputWithCrossAttentions"
>transformers.modeling_outputs.CausalLMOutputWithCrossAttentions</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/pr_21990/en/model_doc/trocr#transformers.TrOCRConfig"
>TrOCRConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>loss</strong> (<code>torch.FloatTensor</code> of shape <code>(1,)</code>, <em>optional</em>, returned when <code>labels</code> is provided) \u2014 Language modeling loss (for next-token prediction).</p>
</li>
<li>
<p><strong>logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, config.vocab_size)</code>) \u2014 Prediction scores of the language modeling head (scores for each vocabulary token before SoftMax).</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings, if the model has an embedding layer, +
one for the output of each layer) of shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the optional initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
<li>
<p><strong>cross_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Cross attentions weights after the attention softmax, used to compute the weighted average in the
cross-attention heads.</p>
</li>
<li>
<p><strong>past_key_values</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>use_cache=True</code> is passed or when <code>config.use_cache=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> tuples of length <code>config.n_layers</code>, with each tuple containing the cached key,
value states of the self-attention and the cross-attention layers if model is used in encoder-decoder
setting. Only relevant if <code>config.is_decoder = True</code>.</p>
<p>Contains pre-computed hidden-states (key and values in the attention blocks) that can be used (see
<code>past_key_values</code> input) to speed up sequential decoding.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_21990/en/main_classes/output#transformers.modeling_outputs.CausalLMOutputWithCrossAttentions"
>transformers.modeling_outputs.CausalLMOutputWithCrossAttentions</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),Oe=new Nl({props:{anchor:"transformers.TrOCRForCausalLM.forward.example",$$slots:{default:[Kl]},$$scope:{ctx:B}}}),{c(){f=s("meta"),$=c(),u=s("h1"),g=s("a"),y=s("span"),v(p.$$.fragment),_=c(),q=s("span"),z=r("TrOCR"),P=c(),I=s("h2"),M=s("a"),A=s("span"),v(G.$$.fragment),Et=c(),ie=s("span"),Br=r("Overview"),Ho=c(),U=s("p"),Gr=r("The TrOCR model was proposed in "),Pe=s("a"),Ur=r(`TrOCR: Transformer-based Optical Character Recognition with Pre-trained
Models`),Xr=r(` by Minghao Li, Tengchao Lv, Lei Cui, Yijuan Lu, Dinei Florencio, Cha Zhang,
Zhoujun Li, Furu Wei. TrOCR consists of an image Transformer encoder and an autoregressive text Transformer decoder to
perform `),Me=s("a"),Zr=r("optical character recognition (OCR)"),Jr=r("."),Wo=c(),xt=s("p"),Yr=r("The abstract from the paper is the following:"),Bo=c(),Pt=s("p"),no=s("em"),Kr=r(`Text recognition is a long-standing research problem for document digitalization. Existing approaches for text recognition
are usually built based on CNN for image understanding and RNN for char-level text generation. In addition, another language
model is usually needed to improve the overall accuracy as a post-processing step. In this paper, we propose an end-to-end
text recognition approach with pre-trained image Transformer and text Transformer models, namely TrOCR, which leverages the
Transformer architecture for both image understanding and wordpiece-level text generation. The TrOCR model is simple but
effective, and can be pre-trained with large-scale synthetic data and fine-tuned with human-labeled datasets. Experiments
show that the TrOCR model outperforms the current state-of-the-art models on both printed and handwritten text recognition
tasks.`),Go=c(),le=s("img"),Uo=c(),de=s("small"),Qr=r("TrOCR architecture. Taken from the "),Mt=s("a"),ea=r("original paper"),ta=r("."),Xo=c(),ce=s("p"),oa=r("Please refer to the "),io=s("code"),ra=r("VisionEncoderDecoder"),aa=r(" class on how to use this model."),Zo=c(),X=s("p"),sa=r("This model was contributed by "),Ie=s("a"),na=r("nielsr"),ia=r(`. The original code can be found
`),Ae=s("a"),la=r("here"),da=r("."),Jo=c(),It=s("p"),ca=r("Tips:"),Yo=c(),Z=s("ul"),je=s("li"),ha=r("The quickest way to get started with TrOCR is by checking the "),Le=s("a"),ma=r(`tutorial
notebooks`),pa=r(`, which show how to use the model
at inference time as well as fine-tuning on custom data.`),fa=c(),S=s("li"),ua=r(`TrOCR is pre-trained in 2 stages before being fine-tuned on downstream datasets. It achieves state-of-the-art results
on both printed (e.g. the `),ze=s("a"),ga=r("SROIE dataset"),_a=r(" and handwritten (e.g. the "),De=s("a"),va=r(`IAM
Handwriting dataset`),Ta=r(` text recognition tasks. For more
information, see the `),qe=s("a"),ba=r("official models"),Ca=r("."),wa=c(),Fe=s("li"),ka=r("TrOCR is always used within the "),At=s("a"),Oa=r("VisionEncoderDecoder"),ya=r(" framework."),Ko=c(),Q=s("h2"),he=s("a"),lo=s("span"),v(Ne.$$.fragment),Ra=c(),co=s("span"),$a=r("Resources"),Qo=c(),jt=s("p"),Ea=r("A list of official Hugging Face and community (indicated by \u{1F30E}) resources to help you get started with TrOCR. If you\u2019re interested in submitting a resource to be included here, please feel free to open a Pull Request and we\u2019ll review it! The resource should ideally demonstrate something new instead of duplicating an existing resource."),er=c(),v(Ve.$$.fragment),tr=c(),j=s("ul"),Se=s("li"),xa=r("A blog post on "),He=s("a"),Pa=r("Accelerating Document AI"),Ma=r(" with TrOCR."),Ia=c(),We=s("li"),Aa=r("A blog post on how to "),Be=s("a"),ja=r("Document AI"),La=r(" with TrOCR."),za=c(),Ge=s("li"),Da=r("A notebook on how to "),Ue=s("a"),qa=r("finetune TrOCR on IAM Handwriting Database using Seq2SeqTrainer"),Fa=r("."),Na=c(),Xe=s("li"),Va=r("A notebook on "),Ze=s("a"),Sa=r("inference with TrOCR"),Ha=r(" and Gradio demo."),Wa=c(),Je=s("li"),Ba=r("A notebook on "),Ye=s("a"),Ga=r("finetune TrOCR on the IAM Handwriting Database"),Ua=r(" using native PyTorch."),Xa=c(),Ke=s("li"),Za=r("A notebook on "),Qe=s("a"),Ja=r("evaluating TrOCR on the IAM test set"),Ya=r("."),or=c(),v(et.$$.fragment),rr=c(),Lt=s("ul"),zt=s("li"),tt=s("a"),Ka=r("Casual language modeling"),Qa=r(" task guide."),ar=c(),Dt=s("p"),es=r("\u26A1\uFE0F Inference"),sr=c(),qt=s("ul"),ot=s("li"),ts=r("An interactive-demo on "),rt=s("a"),os=r("TrOCR handwritten character recognition"),rs=r("."),nr=c(),ee=s("h2"),me=s("a"),ho=s("span"),v(at.$$.fragment),as=c(),mo=s("span"),ss=r("Inference"),ir=c(),J=s("p"),ns=r("TrOCR\u2019s "),po=s("code"),is=r("VisionEncoderDecoder"),ls=r(` model accepts images as input and makes use of
`),Ft=s("a"),ds=r("generate()"),cs=r(" to autoregressively generate text given the input image."),lr=c(),O=s("p"),hs=r("The ["),fo=s("code"),ms=r("ViTImageProcessor"),ps=r("/"),uo=s("code"),fs=r("DeiTImageProcessor"),us=r(`] class is responsible for preprocessing the input image and
[`),go=s("code"),gs=r("RobertaTokenizer"),_s=r("/"),_o=s("code"),vs=r("XLMRobertaTokenizer"),Ts=r(`] decodes the generated target tokens to the target string. The
`),Nt=s("a"),bs=r("TrOCRProcessor"),Cs=r(" wraps ["),vo=s("code"),ws=r("ViTImageProcessor"),ks=r("/"),To=s("code"),Os=r("DeiTImageProcessor"),ys=r("] and ["),bo=s("code"),Rs=r("RobertaTokenizer"),$s=r("/"),Co=s("code"),Es=r("XLMRobertaTokenizer"),xs=r(`]
into a single instance to both extract the input features and decode the predicted token ids.`),dr=c(),Vt=s("ul"),wo=s("li"),Ps=r("Step-by-step Optical Character Recognition (OCR)"),cr=c(),v(st.$$.fragment),hr=c(),pe=s("p"),Ms=r("See the "),nt=s("a"),Is=r("model hub"),As=r(" to look for TrOCR checkpoints."),mr=c(),te=s("h2"),fe=s("a"),ko=s("span"),v(it.$$.fragment),js=c(),Oo=s("span"),Ls=r("TrOCRConfig"),pr=c(),F=s("div"),v(lt.$$.fragment),zs=c(),oe=s("p"),Ds=r("This is the configuration class to store the configuration of a "),St=s("a"),qs=r("TrOCRForCausalLM"),Fs=r(`. It is used to instantiate an
TrOCR model according to the specified arguments, defining the model architecture. Instantiating a configuration
with the defaults will yield a similar configuration to that of the TrOCR
`),dt=s("a"),Ns=r("microsoft/trocr-base-handwritten"),Vs=r(" architecture."),Ss=c(),re=s("p"),Hs=r("Configuration objects inherit from "),Ht=s("a"),Ws=r("PretrainedConfig"),Bs=r(` and can be used to control the model outputs. Read the
documentation from `),Wt=s("a"),Gs=r("PretrainedConfig"),Us=r(" for more information."),Xs=c(),v(ue.$$.fragment),fr=c(),ae=s("h2"),ge=s("a"),yo=s("span"),v(ct.$$.fragment),Zs=c(),Ro=s("span"),Js=r("TrOCRProcessor"),ur=c(),R=s("div"),v(ht.$$.fragment),Ys=c(),$o=s("p"),Ks=r("Constructs a TrOCR processor which wraps a vision image processor and a TrOCR tokenizer into a single processor."),Qs=c(),x=s("p"),Bt=s("a"),en=r("TrOCRProcessor"),tn=r(" offers all the functionalities of ["),Eo=s("code"),on=r("ViTImageProcessor"),rn=r("/"),xo=s("code"),an=r("DeiTImageProcessor"),sn=r(`] and
[`),Po=s("code"),nn=r("RobertaTokenizer"),ln=r("/"),Mo=s("code"),dn=r("XLMRobertaTokenizer"),cn=r("]. See the "),mt=s("a"),Io=s("strong"),hn=r("call"),mn=r("()"),pn=r(" and "),Gt=s("a"),fn=r("decode()"),un=r(` for
more information.`),gn=c(),_e=s("div"),v(pt.$$.fragment),_n=c(),H=s("p"),vn=r(`When used in normal mode, this method forwards all its arguments to AutoImageProcessor\u2019s
`),Ao=s("code"),Tn=r("__call__()"),bn=r(` and returns its output. If used in the context
`),jo=s("code"),Cn=r("as_target_processor()"),wn=r(` this method forwards all its arguments to TrOCRTokenizer\u2019s
`),Lo=s("code"),kn=r("~TrOCRTokenizer.__call__"),On=r(". Please refer to the doctsring of the above two methods for more information."),yn=c(),Y=s("div"),v(ft.$$.fragment),Rn=c(),zo=s("p"),$n=r("Instantiate a processor associated with a pretrained model."),En=c(),v(ve.$$.fragment),xn=c(),K=s("div"),v(ut.$$.fragment),Pn=c(),gt=s("p"),Mn=r(`Saves the attributes of this processor (feature extractor, tokenizer\u2026) in the specified directory so that it
can be reloaded using the `),Ut=s("a"),In=r("from_pretrained()"),An=r(" method."),jn=c(),v(Te.$$.fragment),Ln=c(),be=s("div"),v(_t.$$.fragment),zn=c(),vt=s("p"),Dn=r("This method forwards all its arguments to TrOCRTokenizer\u2019s "),Xt=s("a"),qn=r("batch_decode()"),Fn=r(`. Please refer
to the docstring of this method for more information.`),Nn=c(),Ce=s("div"),v(Tt.$$.fragment),Vn=c(),bt=s("p"),Sn=r("This method forwards all its arguments to TrOCRTokenizer\u2019s "),Zt=s("a"),Hn=r("decode()"),Wn=r(`. Please refer to the
docstring of this method for more information.`),gr=c(),se=s("h2"),we=s("a"),Do=s("span"),v(Ct.$$.fragment),Bn=c(),qo=s("span"),Gn=r("TrOCRForCausalLM"),_r=c(),N=s("div"),v(wt.$$.fragment),Un=c(),W=s("p"),Xn=r("The TrOCR Decoder with a language modeling head. Can be used as the decoder part of "),Jt=s("a"),Zn=r("EncoderDecoderModel"),Jn=r(" and "),Fo=s("code"),Yn=r("VisionEncoderDecoder"),Kn=r(`.
This model inherits from `),Yt=s("a"),Qn=r("PreTrainedModel"),ei=r(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),ti=c(),kt=s("p"),oi=r("This model is also a PyTorch "),Ot=s("a"),ri=r("torch.nn.Module"),ai=r(` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),si=c(),ke=s("div"),v(yt.$$.fragment),ni=c(),v(Oe.$$.fragment),this.h()},l(t){const d=Gl('[data-svelte="svelte-1phssyn"]',document.head);f=n(d,"META",{name:!0,content:!0}),d.forEach(o),$=h(t),u=n(t,"H1",{class:!0});var Rt=i(u);g=n(Rt,"A",{id:!0,class:!0,href:!0});var No=i(g);y=n(No,"SPAN",{});var Vo=i(y);T(p.$$.fragment,Vo),Vo.forEach(o),No.forEach(o),_=h(Rt),q=n(Rt,"SPAN",{});var So=i(q);z=a(So,"TrOCR"),So.forEach(o),Rt.forEach(o),P=h(t),I=n(t,"H2",{class:!0});var Tr=i(I);M=n(Tr,"A",{id:!0,class:!0,href:!0});var hi=i(M);A=n(hi,"SPAN",{});var mi=i(A);T(G.$$.fragment,mi),mi.forEach(o),hi.forEach(o),Et=h(Tr),ie=n(Tr,"SPAN",{});var pi=i(ie);Br=a(pi,"Overview"),pi.forEach(o),Tr.forEach(o),Ho=h(t),U=n(t,"P",{});var Kt=i(U);Gr=a(Kt,"The TrOCR model was proposed in "),Pe=n(Kt,"A",{href:!0,rel:!0});var fi=i(Pe);Ur=a(fi,`TrOCR: Transformer-based Optical Character Recognition with Pre-trained
Models`),fi.forEach(o),Xr=a(Kt,` by Minghao Li, Tengchao Lv, Lei Cui, Yijuan Lu, Dinei Florencio, Cha Zhang,
Zhoujun Li, Furu Wei. TrOCR consists of an image Transformer encoder and an autoregressive text Transformer decoder to
perform `),Me=n(Kt,"A",{href:!0,rel:!0});var ui=i(Me);Zr=a(ui,"optical character recognition (OCR)"),ui.forEach(o),Jr=a(Kt,"."),Kt.forEach(o),Wo=h(t),xt=n(t,"P",{});var gi=i(xt);Yr=a(gi,"The abstract from the paper is the following:"),gi.forEach(o),Bo=h(t),Pt=n(t,"P",{});var _i=i(Pt);no=n(_i,"EM",{});var vi=i(no);Kr=a(vi,`Text recognition is a long-standing research problem for document digitalization. Existing approaches for text recognition
are usually built based on CNN for image understanding and RNN for char-level text generation. In addition, another language
model is usually needed to improve the overall accuracy as a post-processing step. In this paper, we propose an end-to-end
text recognition approach with pre-trained image Transformer and text Transformer models, namely TrOCR, which leverages the
Transformer architecture for both image understanding and wordpiece-level text generation. The TrOCR model is simple but
effective, and can be pre-trained with large-scale synthetic data and fine-tuned with human-labeled datasets. Experiments
show that the TrOCR model outperforms the current state-of-the-art models on both printed and handwritten text recognition
tasks.`),vi.forEach(o),_i.forEach(o),Go=h(t),le=n(t,"IMG",{src:!0,alt:!0,width:!0}),Uo=h(t),de=n(t,"SMALL",{});var br=i(de);Qr=a(br,"TrOCR architecture. Taken from the "),Mt=n(br,"A",{href:!0});var Ti=i(Mt);ea=a(Ti,"original paper"),Ti.forEach(o),ta=a(br,"."),br.forEach(o),Xo=h(t),ce=n(t,"P",{});var Cr=i(ce);oa=a(Cr,"Please refer to the "),io=n(Cr,"CODE",{});var bi=i(io);ra=a(bi,"VisionEncoderDecoder"),bi.forEach(o),aa=a(Cr," class on how to use this model."),Cr.forEach(o),Zo=h(t),X=n(t,"P",{});var Qt=i(X);sa=a(Qt,"This model was contributed by "),Ie=n(Qt,"A",{href:!0,rel:!0});var Ci=i(Ie);na=a(Ci,"nielsr"),Ci.forEach(o),ia=a(Qt,`. The original code can be found
`),Ae=n(Qt,"A",{href:!0,rel:!0});var wi=i(Ae);la=a(wi,"here"),wi.forEach(o),da=a(Qt,"."),Qt.forEach(o),Jo=h(t),It=n(t,"P",{});var ki=i(It);ca=a(ki,"Tips:"),ki.forEach(o),Yo=h(t),Z=n(t,"UL",{});var eo=i(Z);je=n(eo,"LI",{});var wr=i(je);ha=a(wr,"The quickest way to get started with TrOCR is by checking the "),Le=n(wr,"A",{href:!0,rel:!0});var Oi=i(Le);ma=a(Oi,`tutorial
notebooks`),Oi.forEach(o),pa=a(wr,`, which show how to use the model
at inference time as well as fine-tuning on custom data.`),wr.forEach(o),fa=h(eo),S=n(eo,"LI",{});var ye=i(S);ua=a(ye,`TrOCR is pre-trained in 2 stages before being fine-tuned on downstream datasets. It achieves state-of-the-art results
on both printed (e.g. the `),ze=n(ye,"A",{href:!0,rel:!0});var yi=i(ze);ga=a(yi,"SROIE dataset"),yi.forEach(o),_a=a(ye," and handwritten (e.g. the "),De=n(ye,"A",{href:!0,rel:!0});var Ri=i(De);va=a(Ri,`IAM
Handwriting dataset`),Ri.forEach(o),Ta=a(ye,` text recognition tasks. For more
information, see the `),qe=n(ye,"A",{href:!0,rel:!0});var $i=i(qe);ba=a($i,"official models"),$i.forEach(o),Ca=a(ye,"."),ye.forEach(o),wa=h(eo),Fe=n(eo,"LI",{});var kr=i(Fe);ka=a(kr,"TrOCR is always used within the "),At=n(kr,"A",{href:!0});var Ei=i(At);Oa=a(Ei,"VisionEncoderDecoder"),Ei.forEach(o),ya=a(kr," framework."),kr.forEach(o),eo.forEach(o),Ko=h(t),Q=n(t,"H2",{class:!0});var Or=i(Q);he=n(Or,"A",{id:!0,class:!0,href:!0});var xi=i(he);lo=n(xi,"SPAN",{});var Pi=i(lo);T(Ne.$$.fragment,Pi),Pi.forEach(o),xi.forEach(o),Ra=h(Or),co=n(Or,"SPAN",{});var Mi=i(co);$a=a(Mi,"Resources"),Mi.forEach(o),Or.forEach(o),Qo=h(t),jt=n(t,"P",{});var Ii=i(jt);Ea=a(Ii,"A list of official Hugging Face and community (indicated by \u{1F30E}) resources to help you get started with TrOCR. If you\u2019re interested in submitting a resource to be included here, please feel free to open a Pull Request and we\u2019ll review it! The resource should ideally demonstrate something new instead of duplicating an existing resource."),Ii.forEach(o),er=h(t),T(Ve.$$.fragment,t),tr=h(t),j=n(t,"UL",{});var V=i(j);Se=n(V,"LI",{});var yr=i(Se);xa=a(yr,"A blog post on "),He=n(yr,"A",{href:!0,rel:!0});var Ai=i(He);Pa=a(Ai,"Accelerating Document AI"),Ai.forEach(o),Ma=a(yr," with TrOCR."),yr.forEach(o),Ia=h(V),We=n(V,"LI",{});var Rr=i(We);Aa=a(Rr,"A blog post on how to "),Be=n(Rr,"A",{href:!0,rel:!0});var ji=i(Be);ja=a(ji,"Document AI"),ji.forEach(o),La=a(Rr," with TrOCR."),Rr.forEach(o),za=h(V),Ge=n(V,"LI",{});var $r=i(Ge);Da=a($r,"A notebook on how to "),Ue=n($r,"A",{href:!0,rel:!0});var Li=i(Ue);qa=a(Li,"finetune TrOCR on IAM Handwriting Database using Seq2SeqTrainer"),Li.forEach(o),Fa=a($r,"."),$r.forEach(o),Na=h(V),Xe=n(V,"LI",{});var Er=i(Xe);Va=a(Er,"A notebook on "),Ze=n(Er,"A",{href:!0,rel:!0});var zi=i(Ze);Sa=a(zi,"inference with TrOCR"),zi.forEach(o),Ha=a(Er," and Gradio demo."),Er.forEach(o),Wa=h(V),Je=n(V,"LI",{});var xr=i(Je);Ba=a(xr,"A notebook on "),Ye=n(xr,"A",{href:!0,rel:!0});var Di=i(Ye);Ga=a(Di,"finetune TrOCR on the IAM Handwriting Database"),Di.forEach(o),Ua=a(xr," using native PyTorch."),xr.forEach(o),Xa=h(V),Ke=n(V,"LI",{});var Pr=i(Ke);Za=a(Pr,"A notebook on "),Qe=n(Pr,"A",{href:!0,rel:!0});var qi=i(Qe);Ja=a(qi,"evaluating TrOCR on the IAM test set"),qi.forEach(o),Ya=a(Pr,"."),Pr.forEach(o),V.forEach(o),or=h(t),T(et.$$.fragment,t),rr=h(t),Lt=n(t,"UL",{});var Fi=i(Lt);zt=n(Fi,"LI",{});var ii=i(zt);tt=n(ii,"A",{href:!0,rel:!0});var Ni=i(tt);Ka=a(Ni,"Casual language modeling"),Ni.forEach(o),Qa=a(ii," task guide."),ii.forEach(o),Fi.forEach(o),ar=h(t),Dt=n(t,"P",{});var Vi=i(Dt);es=a(Vi,"\u26A1\uFE0F Inference"),Vi.forEach(o),sr=h(t),qt=n(t,"UL",{});var Si=i(qt);ot=n(Si,"LI",{});var Mr=i(ot);ts=a(Mr,"An interactive-demo on "),rt=n(Mr,"A",{href:!0,rel:!0});var Hi=i(rt);os=a(Hi,"TrOCR handwritten character recognition"),Hi.forEach(o),rs=a(Mr,"."),Mr.forEach(o),Si.forEach(o),nr=h(t),ee=n(t,"H2",{class:!0});var Ir=i(ee);me=n(Ir,"A",{id:!0,class:!0,href:!0});var Wi=i(me);ho=n(Wi,"SPAN",{});var Bi=i(ho);T(at.$$.fragment,Bi),Bi.forEach(o),Wi.forEach(o),as=h(Ir),mo=n(Ir,"SPAN",{});var Gi=i(mo);ss=a(Gi,"Inference"),Gi.forEach(o),Ir.forEach(o),ir=h(t),J=n(t,"P",{});var to=i(J);ns=a(to,"TrOCR\u2019s "),po=n(to,"CODE",{});var Ui=i(po);is=a(Ui,"VisionEncoderDecoder"),Ui.forEach(o),ls=a(to,` model accepts images as input and makes use of
`),Ft=n(to,"A",{href:!0});var Xi=i(Ft);ds=a(Xi,"generate()"),Xi.forEach(o),cs=a(to," to autoregressively generate text given the input image."),to.forEach(o),lr=h(t),O=n(t,"P",{});var E=i(O);hs=a(E,"The ["),fo=n(E,"CODE",{});var Zi=i(fo);ms=a(Zi,"ViTImageProcessor"),Zi.forEach(o),ps=a(E,"/"),uo=n(E,"CODE",{});var Ji=i(uo);fs=a(Ji,"DeiTImageProcessor"),Ji.forEach(o),us=a(E,`] class is responsible for preprocessing the input image and
[`),go=n(E,"CODE",{});var Yi=i(go);gs=a(Yi,"RobertaTokenizer"),Yi.forEach(o),_s=a(E,"/"),_o=n(E,"CODE",{});var Ki=i(_o);vs=a(Ki,"XLMRobertaTokenizer"),Ki.forEach(o),Ts=a(E,`] decodes the generated target tokens to the target string. The
`),Nt=n(E,"A",{href:!0});var Qi=i(Nt);bs=a(Qi,"TrOCRProcessor"),Qi.forEach(o),Cs=a(E," wraps ["),vo=n(E,"CODE",{});var el=i(vo);ws=a(el,"ViTImageProcessor"),el.forEach(o),ks=a(E,"/"),To=n(E,"CODE",{});var tl=i(To);Os=a(tl,"DeiTImageProcessor"),tl.forEach(o),ys=a(E,"] and ["),bo=n(E,"CODE",{});var ol=i(bo);Rs=a(ol,"RobertaTokenizer"),ol.forEach(o),$s=a(E,"/"),Co=n(E,"CODE",{});var rl=i(Co);Es=a(rl,"XLMRobertaTokenizer"),rl.forEach(o),xs=a(E,`]
into a single instance to both extract the input features and decode the predicted token ids.`),E.forEach(o),dr=h(t),Vt=n(t,"UL",{});var al=i(Vt);wo=n(al,"LI",{});var sl=i(wo);Ps=a(sl,"Step-by-step Optical Character Recognition (OCR)"),sl.forEach(o),al.forEach(o),cr=h(t),T(st.$$.fragment,t),hr=h(t),pe=n(t,"P",{});var Ar=i(pe);Ms=a(Ar,"See the "),nt=n(Ar,"A",{href:!0,rel:!0});var nl=i(nt);Is=a(nl,"model hub"),nl.forEach(o),As=a(Ar," to look for TrOCR checkpoints."),Ar.forEach(o),mr=h(t),te=n(t,"H2",{class:!0});var jr=i(te);fe=n(jr,"A",{id:!0,class:!0,href:!0});var il=i(fe);ko=n(il,"SPAN",{});var ll=i(ko);T(it.$$.fragment,ll),ll.forEach(o),il.forEach(o),js=h(jr),Oo=n(jr,"SPAN",{});var dl=i(Oo);Ls=a(dl,"TrOCRConfig"),dl.forEach(o),jr.forEach(o),pr=h(t),F=n(t,"DIV",{class:!0});var Re=i(F);T(lt.$$.fragment,Re),zs=h(Re),oe=n(Re,"P",{});var oo=i(oe);Ds=a(oo,"This is the configuration class to store the configuration of a "),St=n(oo,"A",{href:!0});var cl=i(St);qs=a(cl,"TrOCRForCausalLM"),cl.forEach(o),Fs=a(oo,`. It is used to instantiate an
TrOCR model according to the specified arguments, defining the model architecture. Instantiating a configuration
with the defaults will yield a similar configuration to that of the TrOCR
`),dt=n(oo,"A",{href:!0,rel:!0});var hl=i(dt);Ns=a(hl,"microsoft/trocr-base-handwritten"),hl.forEach(o),Vs=a(oo," architecture."),oo.forEach(o),Ss=h(Re),re=n(Re,"P",{});var ro=i(re);Hs=a(ro,"Configuration objects inherit from "),Ht=n(ro,"A",{href:!0});var ml=i(Ht);Ws=a(ml,"PretrainedConfig"),ml.forEach(o),Bs=a(ro,` and can be used to control the model outputs. Read the
documentation from `),Wt=n(ro,"A",{href:!0});var pl=i(Wt);Gs=a(pl,"PretrainedConfig"),pl.forEach(o),Us=a(ro," for more information."),ro.forEach(o),Xs=h(Re),T(ue.$$.fragment,Re),Re.forEach(o),fr=h(t),ae=n(t,"H2",{class:!0});var Lr=i(ae);ge=n(Lr,"A",{id:!0,class:!0,href:!0});var fl=i(ge);yo=n(fl,"SPAN",{});var ul=i(yo);T(ct.$$.fragment,ul),ul.forEach(o),fl.forEach(o),Zs=h(Lr),Ro=n(Lr,"SPAN",{});var gl=i(Ro);Js=a(gl,"TrOCRProcessor"),gl.forEach(o),Lr.forEach(o),ur=h(t),R=n(t,"DIV",{class:!0});var L=i(R);T(ht.$$.fragment,L),Ys=h(L),$o=n(L,"P",{});var _l=i($o);Ks=a(_l,"Constructs a TrOCR processor which wraps a vision image processor and a TrOCR tokenizer into a single processor."),_l.forEach(o),Qs=h(L),x=n(L,"P",{});var D=i(x);Bt=n(D,"A",{href:!0});var vl=i(Bt);en=a(vl,"TrOCRProcessor"),vl.forEach(o),tn=a(D," offers all the functionalities of ["),Eo=n(D,"CODE",{});var Tl=i(Eo);on=a(Tl,"ViTImageProcessor"),Tl.forEach(o),rn=a(D,"/"),xo=n(D,"CODE",{});var bl=i(xo);an=a(bl,"DeiTImageProcessor"),bl.forEach(o),sn=a(D,`] and
[`),Po=n(D,"CODE",{});var Cl=i(Po);nn=a(Cl,"RobertaTokenizer"),Cl.forEach(o),ln=a(D,"/"),Mo=n(D,"CODE",{});var wl=i(Mo);dn=a(wl,"XLMRobertaTokenizer"),wl.forEach(o),cn=a(D,"]. See the "),mt=n(D,"A",{href:!0});var li=i(mt);Io=n(li,"STRONG",{});var kl=i(Io);hn=a(kl,"call"),kl.forEach(o),mn=a(li,"()"),li.forEach(o),pn=a(D," and "),Gt=n(D,"A",{href:!0});var Ol=i(Gt);fn=a(Ol,"decode()"),Ol.forEach(o),un=a(D,` for
more information.`),D.forEach(o),gn=h(L),_e=n(L,"DIV",{class:!0});var zr=i(_e);T(pt.$$.fragment,zr),_n=h(zr),H=n(zr,"P",{});var $e=i(H);vn=a($e,`When used in normal mode, this method forwards all its arguments to AutoImageProcessor\u2019s
`),Ao=n($e,"CODE",{});var yl=i(Ao);Tn=a(yl,"__call__()"),yl.forEach(o),bn=a($e,` and returns its output. If used in the context
`),jo=n($e,"CODE",{});var Rl=i(jo);Cn=a(Rl,"as_target_processor()"),Rl.forEach(o),wn=a($e,` this method forwards all its arguments to TrOCRTokenizer\u2019s
`),Lo=n($e,"CODE",{});var $l=i(Lo);kn=a($l,"~TrOCRTokenizer.__call__"),$l.forEach(o),On=a($e,". Please refer to the doctsring of the above two methods for more information."),$e.forEach(o),zr.forEach(o),yn=h(L),Y=n(L,"DIV",{class:!0});var ao=i(Y);T(ft.$$.fragment,ao),Rn=h(ao),zo=n(ao,"P",{});var El=i(zo);$n=a(El,"Instantiate a processor associated with a pretrained model."),El.forEach(o),En=h(ao),T(ve.$$.fragment,ao),ao.forEach(o),xn=h(L),K=n(L,"DIV",{class:!0});var so=i(K);T(ut.$$.fragment,so),Pn=h(so),gt=n(so,"P",{});var Dr=i(gt);Mn=a(Dr,`Saves the attributes of this processor (feature extractor, tokenizer\u2026) in the specified directory so that it
can be reloaded using the `),Ut=n(Dr,"A",{href:!0});var xl=i(Ut);In=a(xl,"from_pretrained()"),xl.forEach(o),An=a(Dr," method."),Dr.forEach(o),jn=h(so),T(Te.$$.fragment,so),so.forEach(o),Ln=h(L),be=n(L,"DIV",{class:!0});var qr=i(be);T(_t.$$.fragment,qr),zn=h(qr),vt=n(qr,"P",{});var Fr=i(vt);Dn=a(Fr,"This method forwards all its arguments to TrOCRTokenizer\u2019s "),Xt=n(Fr,"A",{href:!0});var Pl=i(Xt);qn=a(Pl,"batch_decode()"),Pl.forEach(o),Fn=a(Fr,`. Please refer
to the docstring of this method for more information.`),Fr.forEach(o),qr.forEach(o),Nn=h(L),Ce=n(L,"DIV",{class:!0});var Nr=i(Ce);T(Tt.$$.fragment,Nr),Vn=h(Nr),bt=n(Nr,"P",{});var Vr=i(bt);Sn=a(Vr,"This method forwards all its arguments to TrOCRTokenizer\u2019s "),Zt=n(Vr,"A",{href:!0});var Ml=i(Zt);Hn=a(Ml,"decode()"),Ml.forEach(o),Wn=a(Vr,`. Please refer to the
docstring of this method for more information.`),Vr.forEach(o),Nr.forEach(o),L.forEach(o),gr=h(t),se=n(t,"H2",{class:!0});var Sr=i(se);we=n(Sr,"A",{id:!0,class:!0,href:!0});var Il=i(we);Do=n(Il,"SPAN",{});var Al=i(Do);T(Ct.$$.fragment,Al),Al.forEach(o),Il.forEach(o),Bn=h(Sr),qo=n(Sr,"SPAN",{});var jl=i(qo);Gn=a(jl,"TrOCRForCausalLM"),jl.forEach(o),Sr.forEach(o),_r=h(t),N=n(t,"DIV",{class:!0});var Ee=i(N);T(wt.$$.fragment,Ee),Un=h(Ee),W=n(Ee,"P",{});var xe=i(W);Xn=a(xe,"The TrOCR Decoder with a language modeling head. Can be used as the decoder part of "),Jt=n(xe,"A",{href:!0});var Ll=i(Jt);Zn=a(Ll,"EncoderDecoderModel"),Ll.forEach(o),Jn=a(xe," and "),Fo=n(xe,"CODE",{});var zl=i(Fo);Yn=a(zl,"VisionEncoderDecoder"),zl.forEach(o),Kn=a(xe,`.
This model inherits from `),Yt=n(xe,"A",{href:!0});var Dl=i(Yt);Qn=a(Dl,"PreTrainedModel"),Dl.forEach(o),ei=a(xe,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),xe.forEach(o),ti=h(Ee),kt=n(Ee,"P",{});var Hr=i(kt);oi=a(Hr,"This model is also a PyTorch "),Ot=n(Hr,"A",{href:!0,rel:!0});var ql=i(Ot);ri=a(ql,"torch.nn.Module"),ql.forEach(o),ai=a(Hr,` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),Hr.forEach(o),si=h(Ee),ke=n(Ee,"DIV",{class:!0});var Wr=i(ke);T(yt.$$.fragment,Wr),ni=h(Wr),T(Oe.$$.fragment,Wr),Wr.forEach(o),Ee.forEach(o),this.h()},h(){l(f,"name","hf:doc:metadata"),l(f,"content",JSON.stringify(ed)),l(g,"id","trocr"),l(g,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(g,"href","#trocr"),l(u,"class","relative group"),l(M,"id","overview"),l(M,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(M,"href","#overview"),l(I,"class","relative group"),l(Pe,"href","https://arxiv.org/abs/2109.10282"),l(Pe,"rel","nofollow"),l(Me,"href","https://en.wikipedia.org/wiki/Optical_character_recognition"),l(Me,"rel","nofollow"),Ul(le.src,ci="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/trocr_architecture.jpg")||l(le,"src",ci),l(le,"alt","drawing"),l(le,"width","600"),l(Mt,"href","https://arxiv.org/abs/2109.10282"),l(Ie,"href","https://huggingface.co/nielsr"),l(Ie,"rel","nofollow"),l(Ae,"href","https://github.com/microsoft/unilm/tree/6f60612e7cc86a2a1ae85c47231507a587ab4e01/trocr"),l(Ae,"rel","nofollow"),l(Le,"href","https://github.com/NielsRogge/Transformers-Tutorials/tree/master/TrOCR"),l(Le,"rel","nofollow"),l(ze,"href","https://paperswithcode.com/dataset/sroie"),l(ze,"rel","nofollow"),l(De,"href","https://fki.tic.heia-fr.ch/databases/iam-handwriting-database%3E"),l(De,"rel","nofollow"),l(qe,"href","https://huggingface.co/models?other=trocr%3E"),l(qe,"rel","nofollow"),l(At,"href","vision-encoder-decoder"),l(he,"id","resources"),l(he,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(he,"href","#resources"),l(Q,"class","relative group"),l(He,"href","https://huggingface.co/blog/document-ai"),l(He,"rel","nofollow"),l(Be,"href","https://github.com/philschmid/document-ai-transformers"),l(Be,"rel","nofollow"),l(Ue,"href","https://colab.research.google.com/github/NielsRogge/Transformers-Tutorials/blob/master/TrOCR/Fine_tune_TrOCR_on_IAM_Handwriting_Database_using_Seq2SeqTrainer.ipynb"),l(Ue,"rel","nofollow"),l(Ze,"href","https://colab.research.google.com/github/NielsRogge/Transformers-Tutorials/blob/master/TrOCR/Inference_with_TrOCR_%2B_Gradio_demo.ipynb"),l(Ze,"rel","nofollow"),l(Ye,"href","https://colab.research.google.com/github/NielsRogge/Transformers-Tutorials/blob/master/TrOCR/Fine_tune_TrOCR_on_IAM_Handwriting_Database_using_native_PyTorch.ipynb"),l(Ye,"rel","nofollow"),l(Qe,"href","https://colab.research.google.com/github/NielsRogge/Transformers-Tutorials/blob/master/TrOCR/Evaluating_TrOCR_base_handwritten_on_the_IAM_test_set.ipynb"),l(Qe,"rel","nofollow"),l(tt,"href","https://huggingface.co/docs/transformers/tasks/language_modeling"),l(tt,"rel","nofollow"),l(rt,"href","https://huggingface.co/spaces/nielsr/TrOCR-handwritten"),l(rt,"rel","nofollow"),l(me,"id","inference"),l(me,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(me,"href","#inference"),l(ee,"class","relative group"),l(Ft,"href","/docs/transformers/pr_21990/en/main_classes/text_generation#transformers.GenerationMixin.generate"),l(Nt,"href","/docs/transformers/pr_21990/en/model_doc/trocr#transformers.TrOCRProcessor"),l(nt,"href","https://huggingface.co/models?filter=trocr"),l(nt,"rel","nofollow"),l(fe,"id","transformers.TrOCRConfig"),l(fe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(fe,"href","#transformers.TrOCRConfig"),l(te,"class","relative group"),l(St,"href","/docs/transformers/pr_21990/en/model_doc/trocr#transformers.TrOCRForCausalLM"),l(dt,"href","https://huggingface.co/microsoft/trocr-base-handwritten"),l(dt,"rel","nofollow"),l(Ht,"href","/docs/transformers/pr_21990/en/main_classes/configuration#transformers.PretrainedConfig"),l(Wt,"href","/docs/transformers/pr_21990/en/main_classes/configuration#transformers.PretrainedConfig"),l(F,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(ge,"id","transformers.TrOCRProcessor"),l(ge,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(ge,"href","#transformers.TrOCRProcessor"),l(ae,"class","relative group"),l(Bt,"href","/docs/transformers/pr_21990/en/model_doc/trocr#transformers.TrOCRProcessor"),l(mt,"href","/docs/transformers/pr_21990/en/model_doc/trocr#transformers.TrOCRProcessor.__call__"),l(Gt,"href","/docs/transformers/pr_21990/en/model_doc/trocr#transformers.TrOCRProcessor.decode"),l(_e,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Y,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Ut,"href","/docs/transformers/pr_21990/en/main_classes/processors#transformers.ProcessorMixin.from_pretrained"),l(K,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Xt,"href","/docs/transformers/pr_21990/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.batch_decode"),l(be,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Zt,"href","/docs/transformers/pr_21990/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.decode"),l(Ce,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(R,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(we,"id","transformers.TrOCRForCausalLM"),l(we,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(we,"href","#transformers.TrOCRForCausalLM"),l(se,"class","relative group"),l(Jt,"href","/docs/transformers/pr_21990/en/model_doc/encoder-decoder#transformers.EncoderDecoderModel"),l(Yt,"href","/docs/transformers/pr_21990/en/main_classes/model#transformers.PreTrainedModel"),l(Ot,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),l(Ot,"rel","nofollow"),l(ke,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(N,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(t,d){e(document.head,f),m(t,$,d),m(t,u,d),e(u,g),e(g,y),b(p,y,null),e(u,_),e(u,q),e(q,z),m(t,P,d),m(t,I,d),e(I,M),e(M,A),b(G,A,null),e(I,Et),e(I,ie),e(ie,Br),m(t,Ho,d),m(t,U,d),e(U,Gr),e(U,Pe),e(Pe,Ur),e(U,Xr),e(U,Me),e(Me,Zr),e(U,Jr),m(t,Wo,d),m(t,xt,d),e(xt,Yr),m(t,Bo,d),m(t,Pt,d),e(Pt,no),e(no,Kr),m(t,Go,d),m(t,le,d),m(t,Uo,d),m(t,de,d),e(de,Qr),e(de,Mt),e(Mt,ea),e(de,ta),m(t,Xo,d),m(t,ce,d),e(ce,oa),e(ce,io),e(io,ra),e(ce,aa),m(t,Zo,d),m(t,X,d),e(X,sa),e(X,Ie),e(Ie,na),e(X,ia),e(X,Ae),e(Ae,la),e(X,da),m(t,Jo,d),m(t,It,d),e(It,ca),m(t,Yo,d),m(t,Z,d),e(Z,je),e(je,ha),e(je,Le),e(Le,ma),e(je,pa),e(Z,fa),e(Z,S),e(S,ua),e(S,ze),e(ze,ga),e(S,_a),e(S,De),e(De,va),e(S,Ta),e(S,qe),e(qe,ba),e(S,Ca),e(Z,wa),e(Z,Fe),e(Fe,ka),e(Fe,At),e(At,Oa),e(Fe,ya),m(t,Ko,d),m(t,Q,d),e(Q,he),e(he,lo),b(Ne,lo,null),e(Q,Ra),e(Q,co),e(co,$a),m(t,Qo,d),m(t,jt,d),e(jt,Ea),m(t,er,d),b(Ve,t,d),m(t,tr,d),m(t,j,d),e(j,Se),e(Se,xa),e(Se,He),e(He,Pa),e(Se,Ma),e(j,Ia),e(j,We),e(We,Aa),e(We,Be),e(Be,ja),e(We,La),e(j,za),e(j,Ge),e(Ge,Da),e(Ge,Ue),e(Ue,qa),e(Ge,Fa),e(j,Na),e(j,Xe),e(Xe,Va),e(Xe,Ze),e(Ze,Sa),e(Xe,Ha),e(j,Wa),e(j,Je),e(Je,Ba),e(Je,Ye),e(Ye,Ga),e(Je,Ua),e(j,Xa),e(j,Ke),e(Ke,Za),e(Ke,Qe),e(Qe,Ja),e(Ke,Ya),m(t,or,d),b(et,t,d),m(t,rr,d),m(t,Lt,d),e(Lt,zt),e(zt,tt),e(tt,Ka),e(zt,Qa),m(t,ar,d),m(t,Dt,d),e(Dt,es),m(t,sr,d),m(t,qt,d),e(qt,ot),e(ot,ts),e(ot,rt),e(rt,os),e(ot,rs),m(t,nr,d),m(t,ee,d),e(ee,me),e(me,ho),b(at,ho,null),e(ee,as),e(ee,mo),e(mo,ss),m(t,ir,d),m(t,J,d),e(J,ns),e(J,po),e(po,is),e(J,ls),e(J,Ft),e(Ft,ds),e(J,cs),m(t,lr,d),m(t,O,d),e(O,hs),e(O,fo),e(fo,ms),e(O,ps),e(O,uo),e(uo,fs),e(O,us),e(O,go),e(go,gs),e(O,_s),e(O,_o),e(_o,vs),e(O,Ts),e(O,Nt),e(Nt,bs),e(O,Cs),e(O,vo),e(vo,ws),e(O,ks),e(O,To),e(To,Os),e(O,ys),e(O,bo),e(bo,Rs),e(O,$s),e(O,Co),e(Co,Es),e(O,xs),m(t,dr,d),m(t,Vt,d),e(Vt,wo),e(wo,Ps),m(t,cr,d),b(st,t,d),m(t,hr,d),m(t,pe,d),e(pe,Ms),e(pe,nt),e(nt,Is),e(pe,As),m(t,mr,d),m(t,te,d),e(te,fe),e(fe,ko),b(it,ko,null),e(te,js),e(te,Oo),e(Oo,Ls),m(t,pr,d),m(t,F,d),b(lt,F,null),e(F,zs),e(F,oe),e(oe,Ds),e(oe,St),e(St,qs),e(oe,Fs),e(oe,dt),e(dt,Ns),e(oe,Vs),e(F,Ss),e(F,re),e(re,Hs),e(re,Ht),e(Ht,Ws),e(re,Bs),e(re,Wt),e(Wt,Gs),e(re,Us),e(F,Xs),b(ue,F,null),m(t,fr,d),m(t,ae,d),e(ae,ge),e(ge,yo),b(ct,yo,null),e(ae,Zs),e(ae,Ro),e(Ro,Js),m(t,ur,d),m(t,R,d),b(ht,R,null),e(R,Ys),e(R,$o),e($o,Ks),e(R,Qs),e(R,x),e(x,Bt),e(Bt,en),e(x,tn),e(x,Eo),e(Eo,on),e(x,rn),e(x,xo),e(xo,an),e(x,sn),e(x,Po),e(Po,nn),e(x,ln),e(x,Mo),e(Mo,dn),e(x,cn),e(x,mt),e(mt,Io),e(Io,hn),e(mt,mn),e(x,pn),e(x,Gt),e(Gt,fn),e(x,un),e(R,gn),e(R,_e),b(pt,_e,null),e(_e,_n),e(_e,H),e(H,vn),e(H,Ao),e(Ao,Tn),e(H,bn),e(H,jo),e(jo,Cn),e(H,wn),e(H,Lo),e(Lo,kn),e(H,On),e(R,yn),e(R,Y),b(ft,Y,null),e(Y,Rn),e(Y,zo),e(zo,$n),e(Y,En),b(ve,Y,null),e(R,xn),e(R,K),b(ut,K,null),e(K,Pn),e(K,gt),e(gt,Mn),e(gt,Ut),e(Ut,In),e(gt,An),e(K,jn),b(Te,K,null),e(R,Ln),e(R,be),b(_t,be,null),e(be,zn),e(be,vt),e(vt,Dn),e(vt,Xt),e(Xt,qn),e(vt,Fn),e(R,Nn),e(R,Ce),b(Tt,Ce,null),e(Ce,Vn),e(Ce,bt),e(bt,Sn),e(bt,Zt),e(Zt,Hn),e(bt,Wn),m(t,gr,d),m(t,se,d),e(se,we),e(we,Do),b(Ct,Do,null),e(se,Bn),e(se,qo),e(qo,Gn),m(t,_r,d),m(t,N,d),b(wt,N,null),e(N,Un),e(N,W),e(W,Xn),e(W,Jt),e(Jt,Zn),e(W,Jn),e(W,Fo),e(Fo,Yn),e(W,Kn),e(W,Yt),e(Yt,Qn),e(W,ei),e(N,ti),e(N,kt),e(kt,oi),e(kt,Ot),e(Ot,ri),e(kt,ai),e(N,si),e(N,ke),b(yt,ke,null),e(ke,ni),b(Oe,ke,null),vr=!0},p(t,[d]){const Rt={};d&2&&(Rt.$$scope={dirty:d,ctx:t}),ue.$set(Rt);const No={};d&2&&(No.$$scope={dirty:d,ctx:t}),ve.$set(No);const Vo={};d&2&&(Vo.$$scope={dirty:d,ctx:t}),Te.$set(Vo);const So={};d&2&&(So.$$scope={dirty:d,ctx:t}),Oe.$set(So)},i(t){vr||(C(p.$$.fragment,t),C(G.$$.fragment,t),C(Ne.$$.fragment,t),C(Ve.$$.fragment,t),C(et.$$.fragment,t),C(at.$$.fragment,t),C(st.$$.fragment,t),C(it.$$.fragment,t),C(lt.$$.fragment,t),C(ue.$$.fragment,t),C(ct.$$.fragment,t),C(ht.$$.fragment,t),C(pt.$$.fragment,t),C(ft.$$.fragment,t),C(ve.$$.fragment,t),C(ut.$$.fragment,t),C(Te.$$.fragment,t),C(_t.$$.fragment,t),C(Tt.$$.fragment,t),C(Ct.$$.fragment,t),C(wt.$$.fragment,t),C(yt.$$.fragment,t),C(Oe.$$.fragment,t),vr=!0)},o(t){w(p.$$.fragment,t),w(G.$$.fragment,t),w(Ne.$$.fragment,t),w(Ve.$$.fragment,t),w(et.$$.fragment,t),w(at.$$.fragment,t),w(st.$$.fragment,t),w(it.$$.fragment,t),w(lt.$$.fragment,t),w(ue.$$.fragment,t),w(ct.$$.fragment,t),w(ht.$$.fragment,t),w(pt.$$.fragment,t),w(ft.$$.fragment,t),w(ve.$$.fragment,t),w(ut.$$.fragment,t),w(Te.$$.fragment,t),w(_t.$$.fragment,t),w(Tt.$$.fragment,t),w(Ct.$$.fragment,t),w(wt.$$.fragment,t),w(yt.$$.fragment,t),w(Oe.$$.fragment,t),vr=!1},d(t){o(f),t&&o($),t&&o(u),k(p),t&&o(P),t&&o(I),k(G),t&&o(Ho),t&&o(U),t&&o(Wo),t&&o(xt),t&&o(Bo),t&&o(Pt),t&&o(Go),t&&o(le),t&&o(Uo),t&&o(de),t&&o(Xo),t&&o(ce),t&&o(Zo),t&&o(X),t&&o(Jo),t&&o(It),t&&o(Yo),t&&o(Z),t&&o(Ko),t&&o(Q),k(Ne),t&&o(Qo),t&&o(jt),t&&o(er),k(Ve,t),t&&o(tr),t&&o(j),t&&o(or),k(et,t),t&&o(rr),t&&o(Lt),t&&o(ar),t&&o(Dt),t&&o(sr),t&&o(qt),t&&o(nr),t&&o(ee),k(at),t&&o(ir),t&&o(J),t&&o(lr),t&&o(O),t&&o(dr),t&&o(Vt),t&&o(cr),k(st,t),t&&o(hr),t&&o(pe),t&&o(mr),t&&o(te),k(it),t&&o(pr),t&&o(F),k(lt),k(ue),t&&o(fr),t&&o(ae),k(ct),t&&o(ur),t&&o(R),k(ht),k(pt),k(ft),k(ve),k(ut),k(Te),k(_t),k(Tt),t&&o(gr),t&&o(se),k(Ct),t&&o(_r),t&&o(N),k(wt),k(yt),k(Oe)}}}const ed={local:"trocr",sections:[{local:"overview",title:"Overview"},{local:"resources",title:"Resources"},{local:"inference",title:"Inference"},{local:"transformers.TrOCRConfig",title:"TrOCRConfig"},{local:"transformers.TrOCRProcessor",title:"TrOCRProcessor"},{local:"transformers.TrOCRForCausalLM",title:"TrOCRForCausalLM"}],title:"TrOCR"};function td(B){return Xl(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class dd extends Hl{constructor(f){super();Wl(this,f,td,Ql,Bl,{})}}export{dd as default,ed as metadata};
